Package: AdvancedR
Type: Package
Title: Advanced R Programming for Bioinformatics
Version: 0.0.3
Author: Martin Morgan <mtmorgan@fhcrc.org>,
        Patrick Aboyoun <paboyoun@fhcrc.org>,
        Marc Carlson <mcarlson@fhcrc.org>,
        Seth Falcon <sfalcon@fhcrc.org>,
        Nishant Gopalakrishnan <ngopalak@fhcrc.org>,
        Chao-Jen Wong <cwon2@fhcrc.org>
Maintainer: Martin Morgan <mtmorgan@fhcrc.org>
License: Artistic-2.0
LazyLoad: yes
Description: This package contains material for 'Advanced R
    Programming for Bioinformatics', offered in Seattle, May, 2010.
Suggests: codetoolsBioC, RUnit, Biobase, limma, IRanges, Biostrings,
          GenomicRanges, GenomicFeatures, foreach, doMC, RSQLite, ncdf
Packaged: 2010-05-24 20:52:05 UTC; mtmorgan

Package: nidemo
Type: Package
Title: Native Interfaces Demo Package
Version: 0.0.1
Author: Seth Falcon <sfalcon@fhcrc.org>
Maintainer: Seth Falcon <sfalcon@fhcrc.org>
License: Artistic-2.0
LazyLoad: yes
Description: A package to demonstrate R's native interfaces for
    use in the course Advanced Programming for Bioinformatics',
    offered in Seattle, May, 2010.

useDynLib("nidemo",
          .nid_avg = nid_avg,
          .nid_alpha_freq = nid_alpha_freq,
          .nid_which = nid_which,
          .nid_buggy_freq = nid_buggy_freq,
          .nid_make_freq_data = nid_make_freq_data,
          .nid_update_freq = nid_update_freq,
          .nid_report_freq = nid_report_freq)

exportPattern("^[^\\.]")

system("hostname")
fname0 <-
    system.file("AdvancedR", "extdata", "gwas_2.csv", package="AdvancedR")
snp0 <- function(i, gwas) {
    snps <- gwas[,-(1:3)]
    glm(CaseControl ~ Age + Sex + snps[,i], family=binomial, 
        data=gwas)$coef
}

gwas <- read.csv(fname0, row.names=1)
result <- lapply(1:20, snp0, gwas)
result[[1]]

library(Rmpi)
mpi.spawn.Rslaves()

## load gwas on each node
mpi.remote.exec({
    fname0 <-
        system.file("AdvancedR", "extdata", "gwas_2.csv", package="AdvancedR")
    gwas <<- read.csv(fname0, row.names=1)
}, ret=FALSE)

## evaluate in parallel
snp0 <- function(i) {
    snps <- gwas[,-(1:3)] ## global reference 'gwas'
    glm(CaseControl ~ Age + Sex + snps[,i], family=binomial, 
        data=gwas)$coef
}
system.time(result <- mpi.parLapply(1:200, snp0))

result[[1]]

mpi.close.Rslaves()
mpi.quit()

extdata <- system.file("extdata", package="AdvancedR")
fname <- file.path(extdata, "gwas_2.rda")
fname0 <- tempfile()
local({
    load(fname)
    write.csv(gwas, fname0)
})

f0 <- function(fileName) {
    read.csv(fileName, row.names=1)
}

f1 <- function(fileName) {
    colClasses <- c("character", "factor", "factor", "integer",
                    rep("NULL", 10000))
    read.csv(fileName, row.names=1, colClasses=colClasses)
}

f2 <- function(fileName) {
    what <- c(list(id=character(),
                   CaseControl=character(),
                   Sex=character(),
                   Age=integer()),
              rep(list(NULL), 10000))
    input <- scan(fileName, what=what, sep=",", skip=1, quiet=TRUE)
    as.data.frame(input[2:4], row.names=input[[1]])
}

shuffle0 <- function(genotypes, seed=123L) {
    set.seed(seed)
    samp <- sample(genotypes)
    g <- unlist(samp)
    matrix(g, ncol=ncol(genotypes))
}

shuffle1 <- function(genotypes, seed=123L) {
    set.seed(seed)
    samp <- sample(genotypes)
    g <- unlist(samp, use.names=FALSE)
    matrix(g, ncol=ncol(genotypes))
}

shuffle2 <- function(genotypes, seed=123L) {
    set.seed(seed)
    as.matrix(sample(genotypes))
}

snp0 <- function(i, gwas) {
    snp <- gwas[,-c(1:3)]
    glm(CaseControl ~ Age + Sex + snp[,i], family=binomial, data=gwas)
}

fapply.csv <-
    function(fname, FUN, ..., nrows=200L, header=TRUE,
             colClasses=NA, col.names, .reduce)
{
    conn <- file(fname, open="r")
    ## first chunk; special: remember header info
    chunk <- read.csv(conn, header=header, ..., nrows=nrows,
                      colClasses=colClasses)
    colClasses <- sapply(chunk, class)
    colNames <- c("", names(chunk))
    result <- list(); it <- 1
    repeat {
        result[[it]] <- FUN(chunk, ...)
        if (nrow(chunk) != nrows) break
        chunk <- read.csv(conn, header=FALSE, ...,
                          nrows=nrows, colClasses=colClasses,
                          col.names=colNames)
        if (nrow(chunk) == 0L) break
        it <- it + 1
    }
    close(conn)
    if (missing(.reduce)) result
    else .reduce(result)
}

# salloc -N 4 orterun -n 1 R -f spawn.R 
library(Rmpi)
nWorkers <- mpi.universe.size() - 1L
mpi.spawn.Rslaves(nsl=nWorkers)
mpi.remote.exec(mpi.comm.rank())
mpiRank <- function(i)
  c(i=i, rank=mpi.comm.rank())
mpi.parSapply(seq_len(2*nWorkers), mpiRank)
mpi.close.Rslaves()
mpi.quit()

## salloc -N 4 orterun -n 4 R --slave -f simd.R
sink("/dev/null") # don't capture output -- more care needed here
library(Rmpi)

TAGS = list(FROM_WORKER=1L)
.comm = 0L

## shared `work', here just determine rank and host
work = c(rank=mpi.comm.rank(.comm),
         host=system("hostname", intern=TRUE))
mpi.barrier(.comm)

if (0L != mpi.comm.rank(.comm)) {
    ## worker
    mpi.send.Robj(work, 0L, TAGS$FROM_WORKER, comm=.comm)
} else {
    ## manager
    nWorkers = mpi.comm.size(.comm)
    res = list(nWorkers)
    for (i in seq_len(nWorkers - 1L))
        res[[i]] <- mpi.recv.Robj(mpi.any.source(), TAGS$FROM_WORKER,
                                  comm=.comm)
    res[[nWorkers]] = work 
    sink() # start capturing output
    print(do.call(rbind, res)) 
}
mpi.quit()

## salloc -N 8 orterun -n 1 R -f random.R
library(Rmpi)

nWorkers = mpi.universe.size() - 1L
mpi.spawn.Rslaves(nsl=nWorkers)
mpi.setup.rngstream()

mpi.parReplicate(20, mean(rnorm(1000)))

g = function(i)
    c(rank=mpi.comm.rank(), mean=mean(rnorm(1000)))
res = mpi.parSapply(1:20, g)
as.data.frame(t(res))

f = function() 
    c(rank=mpi.comm.rank(), mean=mean(rnorm(1000)))
mpi.bcast.Robj2slave(f)
res <- mpi.parReplicate(20, f())
as.data.frame(t(res))

mpi.close.Rslaves()
mpi.quit()

## Initial Classes
setClass("Sample",
         representation("VIRTUAL",
                        description = "character"))

setClass("OneSample", contains = "Sample",
         representation(one = "numeric"))
setClass("TwoSample", contains = "Sample",
         representation(one = "numeric",
                        two = "numeric"))


## Exercise 1
setClass("PairedSample", contains = "TwoSample",
    validity = function(object) {
        if (length(object@one) != length(object@two))
            "unequal sample lengths"
        else
            TRUE
    })


## Exercise 2
setGeneric("tTest", signature = "x",
    function(x, alternative = c("two.sided", "less", "greater"),
             mu = 0, conf.level = 0.95, ...)
        standardGeneric("tTest"))

setMethod("tTest", "OneSample",
    function(x, alternative = c("two.sided", "less", "greater"),
             mu = 0, conf.level = 0.95)
        t.test(x@one, alternative = match.arg(alternative),
               mu = mu, conf.level = conf.level))

setMethod("tTest", "TwoSample",
    function(x, alternative = c("two.sided", "less", "greater"),
             mu = 0, conf.level = 0.95, var.equal = FALSE)
        t.test(x@one, x@two, alternative = match.arg(alternative),
               mu = mu, conf.level = conf.level,
               var.equal = var.equal))

setMethod("tTest", "PairedSample",
    function(x, alternative = c("two.sided", "less", "greater"),
             mu = 0, conf.level = 0.95)
        t.test(x@one, x@two, alternative = match.arg(alternative),
               mu = mu, conf.level = conf.level, paired = TRUE))


## Exercise 3
setMethod("show", "OneSample",
    function(object)
    {
        cat(class(object), "of length", length(object@one), "\n")
        print(object@one)
    })

setMethod("show", "TwoSample",
    function(object)
    {
        cat(class(object), " with lengths ", length(object@one),
            " and ", length(object@two), "\n", sep = "")
        cat("one:\n")
        print(object@one)
        cat("two:\n")
        print(object@two)
    })

setMethod("show", "PairedSample",
    function(object)
    {
        cat(class(object), "of length", length(object@one), "\n")
        print(cbind(one = object@one, two = object@two))
    })

scriptPath <- function(scriptName)
    if (missing(scriptName)) {
        system.file("script", package="AdvancedR")
    } else {
        system.file("script", scriptName, package="AdvancedR")
    }

readScript <- function(scriptName)
    noquote(readLines(scriptPath(scriptName)))

## Ensure that our DLL is unloaded with the package, this allows
## for more convenient dev workflow in which you can reinstall
## the package and then "reload" it by detaching and calling
## library.
.onUnload <- function(libpath) library.dynam.unload("nidemo", libpath)

## A .Call function to compute the average of an integer vector
avg <- function(x) .Call(.nid_avg, as.integer(x))

## Tabulate occurance count of letters 'a'-'z' in a
## text file.
alpha_freq <- function(file)
{
    ans <- .Call(.nid_alpha_freq, file)
    names(ans) <- letters
    ans
}

## Tabulate occurance count of letters 'a'-'z' in a
## text file.  Same as alpha_freq, but in pure R.
alpha_freq_R <- function(file)
{
    ss <- paste(readLines(file), collapse="")
    t <- table(tolower(strsplit(ss, "")[[1]]))
    t <- t[letters]
    t[is.na(t)] <- 0L
    names(t) <- letters
    t
}

## Demo for a C implementation of which()
## x - a logical vector
## returns an integer vector giving the indices
## of the TRUEs in x.
demo_which <- function(x) .Call(.nid_which, x)

## Here's an example of using the .C interface
avg0 <- function(x)
{
    .C("nid_avg0", as.integer(x), length(x),
       ans = double(1),
       PACKAGE = "nidemo")
}

## This is a version of alpha_freq with some bugs intentionally added
## for the purpose of demonstrating how to use gdb.
buggy_freq <- function(file)
{
    ans <- .Call(.nid_buggy_freq, file)
    names(ans) <- letters
    ans
}

## The following three functions provide the API for an external pointer
## based alphabet frequency example.  The purpose is really only to
## demonstrate how to use R external pointers with registered
## finalizers.
##
## Example usage:
##
## x <- make_freq("alice")
## update_freq(x, "some/file.txt")
## update_freq(x, "some/another.txt")
## report_freq(x)
## rm(x)
## gc()
##
## The code is in src/extptrfreq.c

make_freq <- function(id) .Call(.nid_make_freq_data, as.character(id))

update_freq <- function(xp, fname) {
    invisible(.Call(.nid_update_freq, xp, as.character(fname)))
}

report_freq <- function(xp) .Call(.nid_report_freq, xp)

%\VignetteDepends{}
%\VignetteIndexEntry{Building Packages-Exercises}
%\VignettePackage{AdvancedR}

\documentclass{article}

\usepackage[colorlinks=true,linkcolor=blue]{hyperref}
\usepackage{theorem}
\usepackage{underscore}
\usepackage{color}

\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textsf{#1}}}
\newcommand{\Rfunarg}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}

\newcommand{\code}[1]{{\texttt{#1}}}
\newcommand{\file}[1]{{\texttt{#1}}}

\newcommand{\software}[1]{\textsf{#1}}
\newcommand{\R}{\software{R}}
\newcommand{\bioc}{\software{BioConductor}}

%% Excercises and Questions
\theoremstyle{break} \newtheorem{Ex}{Exercise}
\theoremstyle{break} \newtheorem{Q}{Question}
%% And solution or answer
\newenvironment{solution}{\color{blue}}{\bigskip}

\begin{document}

\SweaveOpts{keep.source=TRUE,width=9,height=8,eps=FALSE,include=FALSE,prefix.string=niFig}

\title{Buillding packages: Self-Study Exercises}
\author{Chao-Jen Wong, Nishant Gopalakrishnan}
\date{20 May, 2010}
\maketitle

%% \tableofcontents

<<setup, echo=FALSE>>=
options(width=60)
@

The \Rpackage{AdvancedR} package contains the sources of the
\Rpackage{nidemo} package. The exercises below will take the \Rpackage{nidemo}
package code as a starting point, so you will want to have the source
for this package at hand. If you have installed the \Rpackage{AdvancedR} 
pacakge, you can find the sources for \Rpackage{nidemo} as follows:

<<findingnidemo>>=
system.file("packages", package = "AdvancedR")
@

The main goal of this excercise is to learn how to add unit tests to the
\Rpackage{nidemo} package, by making use of the unit testing framework provided
by the \Rpackage{RUnit} package. 

In the following excercises, we will be creating unit tests for two functions 
\Rfunction{alpha\_freq\_R} and \Rfunction{demo_which} from the 
\Rpackage{nidemo} package. The \Rfunction{alpha\_freq\_R} function returns a
named array containing the number of occurances of each character in a given file.
The \Rfunction{demo_which} function returns the \Robject{TRUE} indices of a 
logical vector.

\begin{Ex}
Build and install the \Rpackage{nidemo} package and test out both
\Rfunction{alpha\_freq\_R} and \Rfunction{demo_which} functions.
\end{Ex}

\begin{Ex}
Create unit tests for functions \Rfunction{alpha\_freq\_R} and 
\Rfunction{demo_which} and save them to the inst/unitTests 
folder of the \Rpackage{nidemo} package.

\noindent Hint: write tests that check for\ldots
\begin{itemize}
\item Correctness of output
\item Exception conditions
\end{itemize}
Hint:
\begin{itemize}
\item \Rpackage{RUnit} relies on file naming conventions; place your
  tests in files whose names match the pattern \verb|".+_test\\.R$"|
\item \Rpackage{RUnit} relies on function naming conventions; each
  unit test function should match \verb|"^test.+"|. Each test should
  be a function with no arguments.
\end{itemize}
\end{Ex}

The \Rfunction{writeRUnitRunner} creates a \Rfunction{.test} function that makes
use of functions from the \Rpackage{RUnit} package to create a test suite, run
the test suite and summarize results.
\begin{Ex}
\begin{itemize}
\item Since we are making use of functions from the \Rpackage{RUnit} package,
 add \Rpackage{RUnit} to the Suggests field of the DESCRIPTION file.
\item Create a \Rfunction{.test} function that runs all the unit tests for 
\Rpackage{nidemo} using the \Rfunction{writeRUnitRunner} function and save it
to the R folder of the \Rpackage{nidemo} package.
\end{itemize}
\end{Ex}


\begin{Ex}
Create an R script in the tests folder of the \Rpackage{nidemo} package
that calls the \Rfunction{.test} function.\\
Hint:
\Rfunction{.test} is not exported from the \Rpackage{nidemo} package. Use \Rfunction{:::}
\end{Ex}

\begin{Ex}
Run R CMD check and verfiy that the \Rpackage{nidemo} passes all the unit tests.
\end{Ex}
\end{document}

%\VignetteDepends{GenomicRanges}
%\VignetteIndexEntry{Databases}
%\VignettePackage{AdvancedR}

\documentclass{beamer}

\usepackage{Bioconductor}
\SweaveOpts{keep.source=TRUE}

\title{Using Databases in R}
\author{Marc Carlson}
\institute[FHCRC]{Fred Hutchinson Cancer Research Center}
\date{May 20, 2010}

\begin{document}

<<setup, echo=FALSE>>=
options(width = 62)
@ 

%% use [fragile] in all frames with Sweave code chunks

\frame{\titlepage}

\section[Outline]{}
\frame{\tableofcontents}




%-----------------------------------------------
%-----------------------------------------------
\section{Introduction}



%-----------------------------------------------
\begin{frame}{Relational Databases}
\begin{block}{Relational database basics}
  \begin{itemize}
    \item Data stored in \textit{tables}
    \item Tables related through \textit{keys}
    \item Relational model called a \textit{schema}
    \item Tables designed to avoid redundancy
  \end{itemize}    
\end{block}
\begin{block}{Beneficial uses by R packages}
  \begin{itemize}
    \item Out-of-memory data storage
    \item Fast access to data subsets
    \item Databases accessible by other software
  \end{itemize}
\end{block}    
\end{frame}



%-----------------------------------------------
\begin{frame}{Uses of Relational Databases in Bioconductor}
\begin{block}{Annotation packages}
  \begin{itemize}
    \item Organism, genome (e.g. \Rpackage{org.Hs.eg.db})
    \item Microarray platforms (e.g. \Rpackage{hgu95av2.db})
    \item Homology (e.g. \Rpackage{hom.Hs.inp.db})
  \end{itemize}    
\end{block}
\begin{block}{Software packages}
  \begin{itemize}
    \item Transcript annotations (e.g. \Rpackage{GenomicFeatures})
    \item NGS experiments (e.g. \Rpackage{Genominator})
    \item Annotation infrastructure (e.g. \Rpackage{AnnotationDbi})
  \end{itemize}
\end{block}    
\end{frame}



%-----------------------------------------------
%-----------------------------------------------

%% Slides to introduce GenomicFeatures and discuss what it does. (and
%% why we store DBs on the disk) (10-15 slides)

\section{Example Databases: The GenomicFeatures Package}
%% Slides to introduce GenomicFeatures and discuss what it does. (and

\begin{frame}{The \Rpackage{GenomicFeatures} package}
  What is does
  \begin{itemize}
    \item Builds databases on the fly as needed.
    \item Supported sources: UCSC tracks, biomaRt, or custom.
    \item Has accessor methods to make it easy to use this data.
  \end{itemize}
  \vskip12pt
  Why it was built
  \begin{itemize}
    \item Needed a generic way to support access to multiple resources
    \item Users needed reproducible data for research
    \item Data needed to be formatted in a convenient way
  \end{itemize}
  \vskip12pt
  Why it uses a database
  \begin{itemize}
    \item Annotation data is highly relational
    \item Other annnotation data is also stored in SQLite databases
    \item Allows access from disc (which can free up memory)
  \end{itemize}
\end{frame}



%-----------------------------------------------
\begin{frame}{What do I mean by relational?}
  \begin{figure}
    \includegraphics[width=4.25in]{database/transcriptschema.png}
  \end{figure}
\end{frame}



%-----------------------------------------------
\begin{frame}[fragile]{TranscriptDb Basics}
\begin{block}{Making a TranscriptDb object}
<<makeUCSC, eval=FALSE>>=
library(GenomicFeatures)
mm9KG <-
  makeTranscriptDbFromUCSC(genome = "mm9",
                           tablename = "knownGene")
@
\end{block}
<<preload, echo=FALSE>>=
library(GenomicFeatures)
if(!exists("mm9KG",mode="TranscriptDb")) {
    mm9KG <-
      loadFeatures(system.file("extdata","mm9KG.sqlite",
                                package = "AdvancedR"))
}
@   
\begin{block}{Saving and Loading}
<<saveAndLoad, eval=FALSE>>=
saveFeatures(mm9KG, file="mm9KG.sqlite")
mm9KG <-
  loadFeatures(system.file("extdata", "mm9KG.sqlite",
                           package = "AdvancedR"))
@
\end{block}
\end{frame}


%-----------------------------------------------
\begin{frame}[fragile, shrink=15]{Accessing the TranscriptDb}
<<transcripts>>=
head(transcripts(mm9KG), 3)
@ 
\end{frame}


%-----------------------------------------------
\begin{frame}[fragile]{What actually happens when we do this?}
<<transcriptsDetails,eval=FALSE>>=
options(verbose=TRUE)
txs <- transcripts(mm9KG)
@ 
\begin{verbatim}
SQL QUERY: SELECT tx_chrom, tx_start, tx_end, tx_strand,
transcript._tx_id AS tx_id , tx_name FROM transcript
ORDER BY tx_chrom, tx_strand, tx_start, tx_end
\end{verbatim}

\begin{block}{}
  Notice how the database query is pretty simple?
  \begin{itemize}
    \item DB joins promote flexible access
    \item BUT: there is a cost if using A LOT of joins
    \item Therefore (in this case) a hybrid approach:
      Retrieve relevant records and subset in R
  \end{itemize}      
\end{block}
\end{frame}


%-----------------------------------------------
\begin{frame}{Our database schema}
  \begin{figure}
    \includegraphics[width=4.25in]{database/transcriptschema.png}
  \end{figure}
\end{frame}



%-----------------------------------------------
%-----------------------------------------------
%% I should probably show people how to see the schemas before I get
%% to this next part...  OR I can show them this next.

\section{Basic SQL}
%% Slides to teach some basic SQL so that people can follow along (10 slides)

\begin{frame}{SQL in 3 slides}
  Structured Query Language (SQL) is the most common language
  for interacting with relational databases.
\end{frame}

%-----------------------------------------------
\begin{frame}[fragile, shrink=15]{Database Retrieval}
\begin{block}{Single table selections}
  \begin{verbatim}
    SELECT * FROM gene;
    SELECT gene_id, gene._tx_id FROM gene;

    SELECT * FROM gene WHERE _tx_id=49245;
    SELECT * FROM transcript WHERE tx_name LIKE '%oap.1'; 
  \end{verbatim}
\end{block}
\begin{block}{Inner joins}
  \begin{verbatim}
    SELECT gene.gene_id,transcript._tx_id
      FROM gene, transcript
      WHERE gene._tx_id=transcript._tx_id;

    SELECT g.gene_id,t._tx_id 
      FROM gene AS g, transcript AS t
      WHERE g._tx_id=t._tx_id
      AND t._tx_id > 10;
  \end{verbatim}
\end{block}
\end{frame}

%-----------------------------------------------
\begin{frame}[fragile, shrink=15]{Database Modifications}
\begin{block}{CREATE TABLE}
  \begin{verbatim}
    CREATE TABLE foo (
      id INTEGER,
      string TEXT
    );
  \end{verbatim}
\end{block}
\begin{block}{INSERT}
  \begin{verbatim}
    INSERT INTO foo (id, string) VALUES (1,"bar");
  \end{verbatim}
\end{block}
\begin{block}{CREATE INDEX}
  \begin{verbatim}
    CREATE INDEX fooInd1 ON foo(id);
  \end{verbatim}
\end{block}
\end{frame}



% DEMO: demonstrate the SQL statements on the test DB.





%-----------------------------------------------
%-----------------------------------------------
\section{Using SQL from within R}
%% Slides to introduce DBI, RSQLite and how these are used to: 1)
%% build DBs, and 2) access the details of this database.(10-15 slides)


%-----------------------------------------------
\begin{frame}[fragile]{The \Rpackage{DBI} package}
  \begin{itemize}
    \item Provides a nice generic access to databases in R
    \item Many of the functions are convenient and simple to use
  \end{itemize}  
\end{frame}


%-----------------------------------------------
\begin{frame}[fragile]{Some popular DBI functions}
<<driverUsageAndListTables>>=
library(RSQLite) #loads DBI too, (but we need both)
drv <- dbDriver("SQLite")
con <- dbConnect(drv, dbname=system.file("extdata", 
                 "mm9KG.sqlite", package="AdvancedR"))
dbListTables(con)
dbListFields(con,"transcript")
@ 
\end{frame}


%-----------------------------------------------
\begin{frame}[fragile]{The dbGetQuery approach}
<<dbGetQuery>>=
dbGetQuery(con, "SELECT * FROM transcript LIMIT 3")
@ 
\end{frame}


%-----------------------------------------------
\begin{frame}[fragile]{The dbSendQuery approach}
If you use result sets, you also need to put them away
<<dbSendQuery>>=
res <- dbSendQuery(con, "SELECT * FROM transcript")
fetch(res, n= 3)
dbClearResult(res)
@ 
Calling fetch again will get the next three results.
This allows for simple iteration.
\end{frame}


%-----------------------------------------------
\begin{frame}[fragile]{Your turn}
Select the exons from the minus strand of chromosome 9.
<<exercise1,echo=FALSE>>=
sql <- "SELECT * FROM exon WHERE exon.exon_strand='-' 
        AND exon.exon_chrom='chr9'"
res <- dbGetQuery(con, sql)
@ 
\end{frame}


%-----------------------------------------------
\begin{frame}[fragile,shrink=15]{Setting up a new DB}
  First, lets close the connection to our other DB:
<<dbDisconnect>>=
   dbDisconnect(con)
@ 
  Then lets make a new database.
  Notice that we specify the database name with "dbname" 
  This allows it to be written to disc instead of just memory.
<<makeNewDb>>=
drv <- dbDriver("SQLite")
con <- dbConnect(drv, dbname="myNewDb.sqlite")
@ 
Once you have this, you may want to make a new table
<<CreateNewTable>>=
dbGetQuery(con, "CREATE Table foo (id INTEGER, string TEXT)")
@ 
\end{frame}


% -----------------------------------------------
\begin{frame}[fragile]{Your turn again}
  Create a database and then put a table in it called genePheno to store the genes mutated and a phenotypes associated with each.  Plan for genePheno to hold the following gene IDs and phenotypes (as a toy example):
\begin{verbatim}
data = data.frame(id=c(69773,20586,258822,18315),
                  string=c("Dead",
                           "Alive",
                           "Dead",
                           "Alive"),
                  stringsAsFactors=FALSE)
\end{verbatim}
<<exercise2,echo=FALSE>>=
drv <- dbDriver("SQLite")
dbcon <- dbConnect(drv, dbname="myExDb.sqlite")
cval <- dbGetQuery(dbcon, 
                   "CREATE Table genePheno 
                    (id INTEGER, string TEXT)")
@ 
\end{frame}


%-----------------------------------------------
\begin{frame}[fragile]{The \Rpackage{RSQLite} package}
  \begin{itemize}
    \item Provides SQLite access for R
    \item Much better support for complex inserts
  \end{itemize}  
\end{frame}




%-----------------------------------------------
\begin{frame}[fragile]{Prepared queries}
<<LabelledPreparedQueries>>=
data <- data.frame(c(226089,66745),
                  c("C030046E11Rik","Trpd52l3"), 
                  stringsAsFactors=FALSE)
names(data) <- c("id","string")
sql <- "INSERT INTO foo VALUES ($id, $string)"
dbBeginTransaction(con)
dbGetPreparedQuery(con, sql, bind.data = data)
dbCommit(con)
@ 
Notice that we want strings instead of factors in our data.frame
\end{frame}




% -----------------------------------------------
\begin{frame}[fragile]{Your turn part 3}
  Now take a moment to insert that data into your database.
<<exercise3,echo=FALSE>>=
data <- data.frame(id=c(69773,20586,258822,18315),
                   string=c("Dead",
                            "Alive",
                            "Dead",
                            "Alive"),
                   stringsAsFactors=FALSE)
sql <- "INSERT INTO genePheno VALUES ($id,$string)"
bval <- dbBeginTransaction(dbcon)
gval <- dbGetPreparedQuery(dbcon, sql, bind.data = data)
cval <- dbCommit(dbcon)
@ 
\end{frame}





%-----------------------------------------------
\begin{frame}[fragile]{in SQLite, you can ATTACH Dbs}
  The SQL what we want looks quite simple:
  \begin{verbatim}
    ATTACH "mm9KG.sqlite" AS db;
  \end{verbatim}  
  So we just need to do something like this:
<<ATTACH>>=
db <- system.file("extdata", "mm9KG.sqlite", 
                  package="AdvancedR")
dbGetQuery(con, sprintf("ATTACH '%s' AS db",db))
@ 
\end{frame}



%-----------------------------------------------
\begin{frame}[fragile, shrink=15]{You can join across attached Dbs}
  The SQL this looks like:
  \begin{verbatim}
    SELECT * FROM db.gene AS dbg, foo AS f 
    WHERE dbg.gene_id=f.id;
  \end{verbatim}  
  Then in R:
<<ATTACHJoin>>=
  sql <- "SELECT * FROM db.gene AS dbg, 
          foo AS f WHERE dbg.gene_id=f.id"
  res <- dbGetQuery(con, sql)
  res
@ 
\end{frame}




% -----------------------------------------------
\begin{frame}[fragile, shrink=15]{Your turn part 4}
  Now create a cross join to your database and extract the \_tx\_id 's from the gene table there using your gene IDs as a foreign key.
<<exercise4,echo=FALSE>>=
  #1st attach
  db <- system.file("extdata", "mm9KG.sqlite", 
                    package="AdvancedR")
  att <- dbGetQuery(dbcon, sprintf("ATTACH '%s' AS db",db))
  #then select
  sql <- "SELECT * FROM db.gene AS dbg, 
          genePheno AS gp WHERE dbg.gene_id=gp.id"
  res <- dbGetQuery(dbcon, sql)
@ 
\end{frame}





%-----------------------------------------------
\begin{frame}[fragile, shrink=15]{Your turn part 5}
 Now conect your cross join to the transcript table in the database and extract the fields from that table while still using your gene IDs as a foreign key.
<<exercise5,echo=FALSE>>=
  sql <- "SELECT * FROM db.gene AS dbg, 
          genePheno AS gp, transcript AS t 
          WHERE dbg.gene_id=gp.id
          AND dbg._tx_id=t._tx_id"
  res <- dbGetQuery(dbcon, sql)
@ 
\end{frame}





%TODO: some things are the wrong size on the laptop

%TODO: AFTER PRINTING: add extra copies of exercise slides (where things are verbatim so that the content is not repeated in the Stangle)
















 
 













%%%% Island of lost slides below:

%% TODO discuss dbname=:memory: (default)
%% TODO discuss RSQLites SQLite() and SQLITE_RO() modes etc.

%% TODO: discuss blobs???
% \begin{frame}[fragile]{handling blobs}
% <<code-block>>=
% @ 
% \end{frame}


%% parallel R on database access- should work now, but benefits for annotation packages are held back (I think) due to caching mechanism.  So instead use direct SQL queries.  So make some slides to discuss that:


% \begin{frame}[fragile]{An overview of the GenomicFeatures package}
% <<code-block>>=
% ## This example ONLY shows improvement for multicore the FIRST time its run...
% ## suspect there is some caching going on...
% library(multicore)
% library(org.Hs.eg.db)
% x <- list(org.Hs.egALIAS2EG, org.Hs.egCHRLOCEND)
% system.time(lapply(x, toTable))
% system.time(mclapply(x, toTable))
% @ 
% \end{frame}


%% mcapply seems to STILL be slower than lapply()...
% \begin{frame}[fragile]{TEST}
% <<code-block>>=
% library(DBI)
% library(RSQLite)
% x = list("genes", "kegg", "pfam", "chromosomes", "accessions", "go_cc_all")
% fun <- function(table){
%   con <- dbConnect(SQLite(), dbname = system.file("extdata","org.Hs.eg.sqlite",package="org.Hs.eg.db") ) 
%   res = sqliteExecStatement(con, paste("SELECT * FROM ",table,sep=""))
%   ans = fetch(res)
%   sqliteCloseResult(res)
% }
% res <- lapply(x, fun)
% head(res[[1]])
% head(res[[2]])

% system.time(lapply(x, fun))
% system.time(mclapply(x, fun))

% @ 
% \end{frame}



% \section{Resources}

% \begin{frame}[fragile]{Resources}
%   %% Include key resources -- urls, books, ...
% \end{frame}







<<cleanup,echo=FALSE>>=
unlink("myNewDb.sqlite")
unlink("myExDb.sqlite")
@ 


\end{document}

%\VignetteDepends{foreach, doMC, RSQLite, ncdf}
%\VignetteSuggests{Rmpi}
%\VignetteIndexEntry{High Performance Computing}
%\VignettePackage{AdvancedR}

\documentclass{beamer}

\usepackage{Bioconductor}
\SweaveOpts{keep.source=TRUE}

\title{High Performance Computing}
\author{Martin Morgan, Seth Falcon}
\institute[FHCRC]{Fred Hutchinson Cancer Research Center}
\date{20-21 May, 2010}

\begin{document}

<<setup, echo=FALSE>>=
options(width = 40)
@ 

\frame{\titlepage}

\begin{frame}{Motivation}
  Challenges
  \begin{itemize}
  \item Long calculations: bootstrap, MCMC, \ldots.
  \item Big data: genome-wide association studies, re-sequencing,
    \ldots.
  \item Long $\times$ big: \ldots
  \end{itemize}
  Solutions
  \begin{itemize}
  \item Avoid \R{} programming pitfalls -- \emph{very} significant
    benefits.
  \item Parallel evaluation, especially `embarrassingly parallel'
  \item Large data management
  \end{itemize}
\end{frame}

\frame{\tableofcontents}

\section{Programming pitfalls}

\subsection{Pitfalls and solutions}

\begin{frame}[fragile]{Programming pitfalls: easy solutions}
  \begin{itemize}
  \item Input only required data
<<io-sketch, eval=FALSE, keep.source=TRUE>>=
colClasses <-
  c("NULL", "integer", "numeric", "NULL")
df <- read.table("myfile", colClasses=colClasses)
@ 
%% 
  \item Preallocate-and-fill, not copy-and-append
<<preallocate-and-fill-sketch, eval=FALSE, keep.source=TRUE>>=
result <- numeric(nrow(df))
for (i in seq_len(nrow(df)))
  result[[i]] <- some_calc(df[i,])
@ 

  \item Vectorized calculations, not iteration
<<iterative, eval=TRUE, keep.source=TRUE>>=
x <- runif(100000); x2 <- x^2
m <- matrix(x2, nrow=1000); y <- rowSums(m)
@ 

  \item Avoid unnecessary character creation operations, e.g.,
    \Rfunarg{USE.NAMES=FALSE} in \Rfunction{sapply}, \Rfunarg{use.names=FALSE}
    in \Rfunction{unlist}.
\end{itemize}
\end{frame}

\begin{frame}[fragile]{Programming pitfalls: moderate solutions}
  \begin{itemize}
  \item Use appropriate functions, often from specialized packages.
<<inappropriate-functions-2, eval=FALSE, keep.source=TRUE>>=
library(limma) # microarray linear models
fit <- lmFit(eSet, design)
@ 
  \item Identify appropriate algorithms, e.g., \Rfunction{\%in\%} is
    $O(N)$, whereas naive might be $O(N^2)$
<<algo-poly, keep.source=TRUE>>=
x <- 1:100; s <- sample(x, 10)
inS <- x %in% s
@ 
  \item Use C or Fortran code. Requires knowledge of other programming
    languages, and how to integrate these into \R{}
  \end{itemize}
\end{frame}

\subsection{Measuring performance}

\begin{frame}[fragile]{Measuring performance: timing}
  \begin{itemize}
  \item Use \Rfunction{system.time} to measure total evaluation time
    \begin{itemize}
    \item \Rfunarg{gcFirst=TRUE} for `garbage collection'
    \end{itemize}
  \item Use \Rfunction{replicate} to average over invocations
  \end{itemize}
<<system.time>>=
m <- matrix(runif(200000), 20000)
replicate(5, system.time(apply(m, 1, sum))[[1]])
replicate(5, system.time(rowSums(m))[[1]])
@ 
\begin{itemize}
\item Cautionary tale: \url{http://tinyurl.com/29bd6xv}
\end{itemize}
\end{frame}

\begin{frame}[fragile]{Measuring performance: comparison}
  \begin{itemize}
  \item \Rfunction{identical} and \Rfunction{all.equal} ensure that
    `optimizations' produce correct results!
  \end{itemize}
<<identical>>=
res1 <- apply(m, 1, sum)
res2 <- rowSums(m)
identical(res1, res2)
identical(c(1, -1), c(x=1, y=-1))
all.equal(c(1, -1), c(x=1, y=-1), check.attributes=FALSE)
@ 
\end{frame}

\begin{frame}[fragile]{Measuring execution time: \Rfunction{Rprof}}

<<Rprof, eval=FALSE, keep.source=TRUE>>=
tmpf = tempfile()
Rprof(tmpf)
res1 <- apply(m,  1, sum)
Rprof(NULL); summaryRprof(tmpf)
@ 
\begin{verbatim}
$by.self
         self.time self.pct total.time total.pct
"apply"       0.16       80       0.20       100
"FUN"         0.02       10       0.02        10
"lapply"      0.02       10       0.02        10
"unlist"      0.00        0       0.02        10

$by.total
         total.time total.pct self.time self.pct
"apply"        0.20       100      0.16       80
"FUN"          0.02        10      0.02       10
"lapply"       0.02        10      0.02       10
"unlist"       0.02        10      0.00        0
\end{verbatim}
\end{frame}

\begin{frame}[fragile]{Measuring memory use: \Rfunction{tracemem}}
  \begin{itemize}
  \item Enable memory profiling
  \end{itemize}
\begin{verbatim}
> ~/src/R-devel/configure --help
> ~/src/R-devel/configure --enable-memory-profiling
> make -j
\end{verbatim}
\begin{itemize}
\item Copy-on-change semantics
\end{itemize}
\begin{verbatim}
> x <- 1:10; tracemem(x)
[1] "<0x1b1a8f8>"
> y <- x       # no change, so no copy
> x[1] <- 2L   # x, y now differ, so copy
tracemem[0x1b1a8f8 -> 0x1b1a8a0]: 
\end{verbatim}
\end{frame}

\begin{frame}[fragile]{Measuring memory use: \Rfunction{tracemem}}
  \begin{itemize}
  \item Copying in \R{} functions
  \end{itemize}
\begin{verbatim}
> l <- list(a=1:10, b=1:10); tracemem(l$a)
[1] "<0x1131ce0>"
> df0 <- as.data.frame(l)
tracemem[0x1131ce0 -> 0x1131bd8]: eval as.data.frame.list as.data.frame 
tracemem[0x1131bd8 -> 0x1131a20]: data.frame eval eval as.data.frame.list as.data.frame 
tracemem[0x1131a20 -> 0x11318c0]: as.data.frame.integer as.data.frame data.frame eval eval as.data.frame.list as.data.frame 
> df1 <- data.frame(a=l$a, b=l$b)
tracemem[0x1131ce0 -> 0x11332c0]: data.frame 
tracemem[0x11332c0 -> 0x1133160]: as.data.frame.integer as.data.frame data.frame 
> identical(df0, df1)
[1] TRUE
\end{verbatim}
\end{frame}

\subsection{Case Study: GWAS}

\begin{frame}[fragile]{Case study: GWAS}
  \begin{itemize}
  \item Subset of genome-wide association study data
  \end{itemize}
<<gwas-input>>=
fname1 <- system.file("extdata", "gwas_2.rda", 
                      package="AdvancedR")
load(fname1)
gwas[1:2, 1:8]
@ 
\end{frame}

\begin{frame}[fragile]{GWAS and glm}
  \begin{itemize}
  \item Interested in fitting generalized linear model to each SNP
  \end{itemize}
<<glm-1>>=
snp0 <- function(i, gwas) {
    snp <- gwas[[i+3L]]
    glm(CaseControl ~ Age + Sex + snp,
        family=binomial, data=gwas)$coef
}
system.time(sapply(1:10, snp0, gwas))
@ 
\end{frame}

\begin{frame}{GWAS case study: further directions}
  \Rfunction{glm} can be optimized for SNPs
  \begin{itemize}
  \item Build the design matrix for \code{CaseControl \~{} Age + Sex}
    once, rather than once per SNP
  \item Use the estimate without the SNP as a starting point
  \item \Rpackage{snpMatrix} fits GLMs very efficiently
  \end{itemize}
  Outcome
  \begin{itemize}
  \item $\sim1000$ SNPs per second
  \end{itemize}
  Important lessons
  \begin{itemize}
  \item Careful optimization can often greatly reduce evaluation time
  \item Others may likely have done the work for you!
  \end{itemize}
\end{frame}

\section{Parallel evaluation}

\subsection{Embarrassingly parallel problems}

\begin{frame}{`Embarrassingly parallel' problems} 
  Problems that are:
  \begin{itemize}
  \item  Easily divisible into different, more-or-less
    identical, independent \emph{tasks}
  \item Tasks distributed across distinct computational \emph{nodes}.
  \item Examples: bootstrap; MCMC; row- or column-wise matrix
    operations; `batch' processing of multiple files, \ldots
  \end{itemize}
  
  What to expect: ideal performance
  \begin{itemize}
  \item Execution time inversely proportional to number of available
    nodes: $10\times$ speed-up requires $10$ nodes, $100\times$
    speedup requires 100 nodes
  \item Communication (data transfer between nodes) is expensive
  \item `Coarse-grained' tasks work best
  \end{itemize}
\end{frame}

\begin{frame}{Packages and other solutions}
  \begin{tabular}{llp{.5\textwidth}}
    Package & Hardware & Challenges \\\hline
    \Rpackage{multicore} & Computer & Not Windows (\Rpackage{doSMP} soon)\\
    \Rpackage{Rmpi} & Cluster & 
      Additional job management software (e.g., slurm) \\
    \Rpackage{snow} & Cluster & 
      Light-weight; convenient if MPI not available \\
    BLAS, \Rpackage{pnmath} & Computer &
      Customize \R{} build; benefits math routines only
  \end{tabular}
  Parallel interfaces
  \begin{itemize}
  \item Package-specific, e.g., \Rfunction{mpi.parLapply}
  \item \Rpackage{foreach}, \Rpackage{iterators}, \Rpackage{doMC},
    \ldots: common interface; fault tolerance; alternative programming
    model
  \end{itemize}
\end{frame}

\begin{frame}{General guidelines for parallel computing}
  \begin{itemize}
  \item Maximize computation per job 
  \item Distribute data implicitly, e.g., using shared file systems
  \item Nodes transform large data to small summary
    \begin{itemize}
    \item     E.g.: \Rpackage{ShortRead} quality assessment.
    \end{itemize}
  \item Construct self-contained functions that avoid global
    variables.
  \item Random numbers need special care!
  \end{itemize}
\end{frame}

\subsection{Packages and evaluation models}

\begin{frame}[fragile]{\Rpackage{multicore}}
  \begin{itemize}
  \item Shared memory, i.e., one computer with several cores
  \end{itemize}
\begin{verbatim}
> system.time(lapply(1:10, snp0, gwas))
   user  system elapsed 
  1.672   0.016   1.687 
> library(multicore)
> system.time(mclapply(1:10, snp0, gwas))
   user  system elapsed 
  1.864   0.348   1.119 
\end{verbatim}
\end{frame}

\begin{frame}[fragile]{\Rpackage{multicore}: under the hood}
  \begin{itemize}
  \item Operating system \code{fork}: new process, initially identical
    to current, OS-level copy-on-change.
  \item \Rfunction{parallel}: spawns new process, returns process id,
    starts expression evaluation.
  \item \Rfunction{collect}: queries process id to retrieve result,
    terminates process.
  \item \code{mclapply}: orchestrates \Rfunction{parallel} /
    \Rfunction{collect}
  \end{itemize}
\end{frame}
  
\begin{frame}[fragile]{\Rpackage{foreach}}
  \begin{itemize}
  \item \Rfunction{foreach}: establishes a \code{for}-like iterator
  \item \Rfunction{\%dopar\%}: infix binary function; left-hand-side:
    \Rfunction{foreach}; right-hand-side: expression for evaluation
  \item Variety of parallel back-ends, e.g., \Rpackage{doMC} for
    \Rpackage{multicore}; register with \Rfunction{registerDoMC}
  \end{itemize}
<<foreach>>=
library(foreach)
if ("windows" != .Platform$OS.type) {
    library(doMC); registerDoMC()
    res <- foreach(i=1:10) %dopar% snp0(i, gwas)
}
@   
\end{frame}

\begin{frame}[fragile]{iterators and foreach}
  \Rpackage{iterators} package
  \begin{itemize}
  \item \Rfunction{iter}: create an iterator on an object
  \item \Rfunction{nextElem}: return the next element of the object
  \item Built-in (e.g, \Rfunction{iapply}, \Rfunction{isplit}) and
    customizable
  \end{itemize}
<<iterators>>=
snp1 <- function(snp, gwas) {
    glm(CaseControl ~ Age + Sex + snp,
        family=binomial, data=gwas)$coef
}
snps <- gwas[,11:20]
res <- foreach(it=iter(snps, "column")) %dopar% 
           snp1(it, gwas)
@ 
\end{frame}

\begin{frame}[fragile]{Rmpi on a cluster}
  \begin{itemize}
  \item `Message passing' interface (MPI)
  \end{itemize}
  Players
  \begin{itemize}
  \item \texttt{slurm}: allocate resources, e.g., \texttt{salloc -N 4}
    allocates 4 nodes for computation
  \item \texttt{mpi}: e.g., \texttt{mpirun -n 1} starts a program on
    one node
  \item \texttt{R} and the \Rpackage{Rmpi} package
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Interactive \Rpackage{Rmpi}: manager / worker}
\begin{verbatim}
hyrax1:~> salloc -N 4 mpirun -n 1 R --interactive --quiet
salloc: Granted job allocation 239631
> library(Rmpi)
> mpi.spawn.Rslaves()
[...SNIP...]
> mpi.parSapply(1:10,
                function(i) c(i=i, rank=mpi.comm.rank()))
     [,1] [,2] [,3] [,4] [,5] [,6] [,7] [,8] [,9] [,10]
i       1    2    3    4    5    6    7    8    9    10
rank    1    1    1    2    2    3    3    4    4     4
> mpi.quit()
salloc: Relinquishing job allocation 239631
\end{verbatim}
\end{frame}

\begin{frame}[fragile]{Manage / worker}
  \begin{itemize}
  \item `Manager' script that spawns workers, tells workers what to
    do, collates results
  \item Submit as `batch' job on a single \R{} node
  \item View example script with \code{readScript("spawn.R")}
  \end{itemize}
\begin{verbatim}
hyrax1:~> salloc -N 4 mpirun -n 1 \
    R CMD BATCH /path/to/spawn.R
\end{verbatim}
\end{frame}

\begin{frame}[fragile]{Single instruction, multiple data (SIMD)}
\begin{itemize}
\item Single script, evaluated on each node, \code{readScript("simd.R")}.
\item Script specializes data for specific node
\item After evaluation, script specializes so that one node collates
  results from others
\end{itemize}
\begin{verbatim}
hyrax1:~> salloc -N 4 mpirun -n 4 \
    R CMD BATCH --slave /path/to/simd.R
\end{verbatim}
\end{frame}

\subsection{Case Study: GWAS (continued)}

\begin{frame}{Case study: GWAS (continued)}
  \begin{itemize}
  \item Readily parallelized -- glm for each SNP fit independently
  \item Divide SNPs into equal sized groups, one group per node
  \item SIMD evaluation model
  \item Need to manage data -- appropriate SNPs and metadata to each
    node
  \end{itemize}
  Important lessons
  \begin{itemize}
  \item Parallel evaluation for real problems can be difficult
  \item Parallelization after optimization
  \item Optimize / parallelize only after confirming that no one else
    has already done the work!
  \end{itemize}
\end{frame}

\section{Large data management}

\begin{frame}{Large data management}
  Putting appropriate data in memory
  \begin{itemize}
  \item An R analysis can make multiple copies of each data set
  \item Limits performance (I/O, but also calculations)
  \item Wastes system resources (e.g., decreasing the number of
    parallel tasks that can be executed)
  \end{itemize}
  Solutions
  \begin{itemize}
  \item Text versus R binary files
  \item `Stream' processing
  \item Data base use
  \item High-performance numeric storage
  \end{itemize}
\end{frame}

\subsection{Text, binary, and streaming I/O}

\begin{frame}[fragile]{Text versus R binary files}
  \begin{itemize}
  \item Text is slower than compressed binary
  \item Compressed binary is slower than binary
  \end{itemize}
<<text-io>>=
ftmp <- tempfile()
write.csv(gwas, ftmp)
system.time(read.csv(ftmp, row.names=1))[[3]]
save(gwas, file=ftmp)
replicate(5, system.time(load(ftmp, new.env()))[[3]])
save(gwas, file=ftmp, compress=FALSE)
replicate(5, system.time(load(ftmp, new.env()))[[3]])
unlink(ftmp)
@ 
\end{frame}

\begin{frame}[fragile]{`Stream' processing}
  \begin{itemize}
  \item Read in a chunk, process, read in next chunk
  \item Use `connections' to keep file open between chunks
  \item Good for very large data sets (if necessary)
  \item A few packages, e.g., \Rpackage{biglm}, exploit this model
  \item See \code{readScript("fapply.R")}
  \end{itemize}
\end{frame}

\subsection{Data bases and netCDF}

\begin{frame}[fragile]{Data bases}
  SQL
  \begin{itemize}
  \item Represent data in a SQL data base
  \item Best for \emph{relational} (structured) data of moderate
    (e.g., millions of rows) size
  \item Not the best solution for, e.g., array-like numerical data
  \end{itemize}
  Use
  \begin{itemize}
  \item \Rpackage{DBI} package provides abstract interface
  \item\Rpackage{RSQLite} (built-in to R), \Rpackage{RMySQL},
    \Rpackage{RPostgreSQL}, ... provide implementations
  \end{itemize}
  Example: \Rpackage{RSQLite} set-up
<<sql-setup>>=
db0 <- tempfile()
library(RSQLite)
drv <- dbDriver("SQLite")
conn <- dbConnect(drv, dbname=db0)
@ 
\end{frame}

\begin{frame}[fragile]{GWAS metadata}
Create
<<sql-create, keep.source=TRUE>>=
gwasPhenotypes <- gwas[,1:3]
dbWriteTable(conn, "gwasPhenotypes", gwasPhenotypes)
@ 
Retrieve
<<db-fetch, keep.source=TRUE>>=
q <- dbSendQuery(conn, "SELECT * FROM gwasPhenotypes")
fetch(q, n = 2) # first 2; n = -1 for all
invisible(dbClearResult(q)) # close out query
@ 
Clean-up
<<db-clean>>=
invisible(dbDisconnect(conn))
@ 
\end{frame}

\begin{frame}[fragile]{NetCDF and the \Rpackage{ncdf} package}
  NetCDF and \Rpackage{ncdf}
  \begin{itemize}
  \item Network Common Data Form: array-oriented scientific data
  \item \Rpackage{ncdf}: R package for NetCDF access
    \begin{itemize}
    \item Warning: character arrays very inefficient in \Rpackage{ncdf}
    \end{itemize}
  \item \Rpackage{ncdf4}: recent; NetCDF 4 format; not yet avaiable
    for Windows
  \end{itemize}
  Data and library
<<ncdf-setup>>=
ngwas <- local({
    x0 <- lapply(gwas[,-(1:3)], as.integer)
    matrix(unlist(x0, use.names=FALSE), ncol=length(x0))
})
ncdf0 <- tempfile()
library(ncdf)
@ 
\end{frame}

\begin{frame}[fragile]{\Rpackage{ncdf}, continued}
  \begin{itemize}
  \item Define dimensions and variable
  \end{itemize}
<<ncdf-define-dims>>=
sampd <- dim.def.ncdf("Sample", "id", seq_len(nrow(ngwas)))
snpd <- dim.def.ncdf("SNP", "id", seq_len(ncol(ngwas)))
snpv <- var.def.ncdf("Genotype", 
                     units="1: AA, 2: AB; 3: BB",
                     dim=list(sampd, snpd), 
                     missval=-1L, prec="integer")
@ 
\begin{itemize}
\item Create file
\end{itemize}
<<ncdf-create-file>>=
nc <- create.ncdf(ncdf0, snpv)
put.var.ncdf(nc, snpv, ngwas)
invisible(close(nc))
@ 
\end{frame}

\begin{frame}[fragile]{\Rpackage{ncdf}, continued}
  \begin{itemize}
  \item Very favorable file I/O performance
  \end{itemize}
<<ncdf-read,keep.source=TRUE>>=
nc <- open.ncdf(ncdf0)
system.time({
    nc_gwas <- get.var.ncdf(nc, "Genotype")
})[[1]]
@ 
  \begin{itemize}
  \item Easy to obtains data slices
  \end{itemize}
<<ncdf-read-II, source=TRUE>>=
g <- get.var.ncdf(nc, "Genotype", start=c(30, 100),
       count=c(10, 20)) # samples 30:40, snps 100:120
g <- get.var.ncdf(nc, "Genotype", start=c(1,1000),
       count=c(-1, 100)) # all samples, snps 1000:1100
invisible(close(nc))
@   
  
\end{frame}

\subsection{Case Study: GWAS (concluded)}

\begin{frame}{Case study: GWAS (concluded)}
  Overall solution
  \begin{itemize}
  \item Optimize \Rfunction{glm} for SNPs
  \item Store SNP data as netCDF, metadata as SQL
  \item Use SIMD model to parallelize calculations
  \end{itemize}
  Outcome
  \begin{itemize}
  \item Initially: $<10$ SNPs per second
  \item Optimized: $\sim1000$ SNP per second
  \item 100 node cluster: $\sim100,000$ SNP per second
  \end{itemize}
\end{frame}

\section{Resources}

\begin{frame}{Resources}
  \begin{itemize}
  \item News group:
    \url{https://stat.ethz.cb/mailman/listinfo/r-sig-hpc}
  \item CRAN Task View:
    \url{http://cran.fhcrc.org/web/views/HighPerformanceComputing.html}
  \item Key packages: \Rpackage{multicore}, \Rpackage{Rmpi},
    \Rpackage{snow}, \Rpackage{foreach} (and friends);
    \Rpackage{RSQlite}, \Rpackage{ncdf}
  \end{itemize}
\end{frame}

\end{document}

%\VignetteDepends{}
%\VignetteIndexEntry{Native Interfaces Exercises}
%\VignettePackage{AdvancedR}

\documentclass{article}

\usepackage[colorlinks=true,linkcolor=blue]{hyperref}
\usepackage{theorem}
\usepackage{underscore}
\usepackage{color}

\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Rmethod}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textsf{#1}}}
\newcommand{\Rfunarg}[1]{{\texttt{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}

\newcommand{\code}[1]{{\texttt{#1}}}
\newcommand{\file}[1]{{\texttt{#1}}}

\newcommand{\software}[1]{\textsf{#1}}
\newcommand{\R}{\software{R}}
\newcommand{\bioc}{\software{BioConductor}}
\newcommand{\ELAND}{\software{ELAND}}
\newcommand{\MAQ}{\software{MAQ}}
\newcommand{\Bowtie}{\software{Bowtie}}

%% Excercises and Questions
\theoremstyle{break} \newtheorem{Ex}{Exercise}
\theoremstyle{break} \newtheorem{Q}{Question}
%% And solution or answer
\newenvironment{solution}{\color{blue}}{\bigskip}

\begin{document}

\SweaveOpts{keep.source=TRUE,width=9,height=8,eps=FALSE,include=FALSE,prefix.string=niFig}

\title{Native Interfaces for R: Self-Study Exercises}
\author{Seth Falcon}
\date{20-21 May, 2010}
\maketitle

%% \tableofcontents

<<setup, echo=FALSE>>=
options(width=60)
@

\section{Exercises}

The \Rpackage{AdvancedR} package contains the sources of the
\Rpackage{nidemo} package that demonstrates how to use R's native
interfaces.  The exercises below will take the \Rpackage{nidemo}
package code as a starting point, so you will want to have the source
for this package at hand.  If you have installed the
\Rpackage{AdvancedR} package, you can find the sources for
\Rpackage{nidemo} as follows:

<<findingnidemo>>=
system.file("packages", package = "AdvancedR")
@

The \Rpackage{nidemo} package contains two versions of a function that
computes the occurrence counts of the letters a--z in a text
file.  The \Rfunction{alpha\_freq\_R} function is written entirely in
R and the \Rfunction{alpha\_freq} function performs the letter
counting in a C function accessed via \Rfunction{.Call}.

\begin{Ex}
  Install the \Rpackage{nidemo} package and test out both
  \Rfunction{alpha\_freq\_R} and \Rfunction{alpha\_freq}.  On
  unix-like systems, a good input file to use for testing is the
  system word dictionary (possibly in \code{/usr/share/dict/words}).

  Use \Rfunction{system.time} to compare the run time for the two
  versions.  You may not see much of a difference if your input file
  is small.
\end{Ex}

  The C function \Rfunction{nid\_alpha\_freq} in
  \code{nidemo/src/charfreq.c} is not very robust.  In particular, the
  function does not verify that the argument it receives is of the
  type that it expects.  When a bad argument is provides, it will
  crash R.

\begin{Ex} \label{exBadInput}
  Try the following inputs to see the ways in which the function
  breaks (NOTE: some or all of these may crash your R session).

  \begin{itemize}
  \item \code{alpha\_freq(TRUE)}
  \item \code{alpha\_freq("")}
  \item \code{alpha\_freq(as.character(NA))}
      \item \code{alpha\_freq(character(0))}
  \end{itemize}
\end{Ex}

\begin{Ex}
  Modify the \Rfunction{nid\_alpha\_freq} function to display a
  standard R error message when the argument provided is invalid.  Do
  this in C, not in the R wrapper function using \code{Rf\_error}.
  After your changes, the function should provide an error message for
  all of the invalid inputs from Exercise~\ref{exBadInput}.  Hint: you
  can use \code{Rf_isString} to test for a character vector.
\end{Ex}

\begin{Ex}
  Force the input to be \code{character(1)} by making it an error if
  the input is not of the right length.  Do this in C.
\end{Ex}

\begin{Ex}
  Use \Rfunction{TYPEOF()} and \Rfunction{Rf_type2char()} to provide a
  more informative error message when the input is not a character
  vector.
\end{Ex}

\begin{Ex}
  The labels for the result table are set in the R wrapper for
  \Rfunction{alpha\_freq}.  Modify the code to set the names of the
  result table in C.  Outline:
  \begin{itemize}
  \item Create a character vector using
    \code{Rf\_allocVector(STRSXP, 26)}
  \item Use \code{SET\_STRING\_ELT} and \code{mkChar} to fill the
    vector
  \item Set this as the names attribute of the return SEXP using
    \code{Rf\_setAttrib}.  The attribute name is
    \code{R\_NamesSymbol}.
  \end{itemize}
\end{Ex}


\begin{Ex}
  At the top of \Rfunction{nid\_alpha\_freq}, an INTSXP is allocated
  using \Rfunction{Rf\_allocVector}.  This vector is protected a few
  lines later.  Is this safe?  Discuss.
\end{Ex}

\begin{Ex}
  Enhance \Rfunction{alpha\_freq} so that it can be given a length $n$
  vector of file names and return an $n \times 26$ matrix with the
  alphabet frequency count for each file.  Set the row names of the
  matrix to be the corresponding file names.  There is an example of
  returning a matrix from a C function in WRE.
\end{Ex}

\section{R Package Development Setup}

\subsection{Makevars customization}

You can ensure that debugging symbols and compiler warnings are
enabled for all packages that you build from source by creating a
\code{Makevars-PLATFORM} file in your home directory (where PLATFORM
matches the output of \verb+R.version$platform+.

<<makevars, eval=FALSE>>=
dir.create("~/.R", showWarnings = FALSE)
lines <- "CFLAGS=-g -Wall -pedantic"
fname <- paste("~/.R/Makevars",
               R.version[["platform"]],
               sep = "-")
writeLines(lines, con = fname)
@

\subsection{Useful items for \code{\$HOME/.Rprofile}}

\begin{itemize}

\item Install packages based on the \verb+R_LIBS_USER+ environment
  variable.  This keeps installed packages separate from the packages
  that come with R and also has the advantage of avoiding mixing
  packages across different versions of R.

\item Set a default CRAN repository

\item Source \code{biocLite} script for interactive sessions.

\item A helper function to reload a package, useful during
  development.

\end{itemize}

\begin{verbatim}
dir.create(Sys.getenv("R_LIBS_USER"),
           recursive = TRUE,
           showWarnings = FALSE)

options(repos="http://cran.fhcrc.org")

if (TRUE && interactive()) {
tryCatch({
    source("http://bioconductor.org/biocLite.R")
}, error=function(e) invisible(NULL),
         warning=function(w) message("Not connected to the net"))
}

reload_pkg <- function(p)
{
    detach(paste("package", p, sep = ":"),
           unload = TRUE, character.only = TRUE)
    library(p, character.only = TRUE)
}

\end{verbatim}

\subsection{Windows Setup}

For reference, read the \textit{Installing R under Windows} in the
\textit{R Installation and Administration} manual.

Download and install the standard R package for Windows.

Download the appropriate version of the Windows tools from
\url{http://www.murdoch-sutherland.com/Rtools/} and install.

Install a package from source as:

\begin{verbatim}
c:\"Program Files\R\R-2.11.0"\bin\R CMD INSTALL nidemo
\end{verbatim}

\section{Exploration of External Pointers}

R provides the EXTPTRSXP type for managing memory that is external to
R.  You can register a \textit{finalizer} that will run when an
external pointers is garbage collected.  See Figure~\ref{figExtPtr}.

\begin{figure}[hb]
  \includegraphics[width=2in]{nativeI/extptrsxp-diagram}
  \caption{Conceptual diagram of R's external pointer type (EXTPTRSXP)}
  \label{figExtPtr}
\end{figure}

The \Rpackage{nidemo} package contains an example of using R's
external pointers.  The code is somewhat contrived, but extends the
alphabet frequency counter to be a persistent data structure such that
you can create a counter and update it with the contents of different
files and then retrieve the cumulative alphabet frequency counts.

A user session looks like this:

<<alphafreqextptrsession, eval=FALSE>>=
x <- make_freq("alice")
update_freq(x, "some/file.txt")
update_freq(x, "some/another.txt")
report_freq(x)
rm(x)
gc()
@

\begin{Ex}
  Read through the implementation of the external pointer based
  alphabet frequency counter and try out a sample session.
\end{Ex}

In addition to registering finalizers at the C-level, it is also
possible to create R-based finalizers using \Rfunction{reg.finalizer}.
One subtlety of finalizers is that any functions called within a
finalizer must satisfy a weak-form of re-entrancy.  Consider the
pseudo-code in Figure~\ref{figReent}.

\begin{figure}
\begin{minipage}{0.8\textwidth}
\begin{verbatim}
f() {
  /* amazing computations */
  g() /* this allocates R objects,
         can trigger gc */
  /* more computations here */
}

finalizer() {
  /* clean up */
  f() /* danger! */
}
\end{verbatim}
\end{minipage}
\caption{Even though R is single-threaded, a second call to \code{f}
  will occur before the first call to \code{f} is finished.  This can
  cause serious problems if \code{f} manipulates global variables or
  modifies its arguments in-place.}
\label{figReent}
\end{figure}

\section{Calling R from C}

You can evaluate R code from C using \code{Rf\_eval}.  This allows
package code to make use of R functions that do not have a C entry
point as well as provide a mechanism for users to specify callback
functions in R that will be executed in the context of package C code.

\begin{Ex}
  Take a few minutes to review the section
  \textit{Evaluating R expressions from C} in the WRE manual.
\end{Ex}

The most elegant way of calling R functions from C is to build a
function call using a LANGSXP and then evaluate it using
\code{Rf\_eval}.  R function calls are represented in C using the
LANGSXP type that provides a linked list data structure.  The first
element of the list must be a symbol naming the function you want to
call (SYMSXP).  Additional elements in the list are the arguments to
the function.

There are helper functions to construct pairlists of different sizes:
\code{lang1}, \code{lang2}, \code{lang3}, \code{lang4}.  Below,
\code{Rf\_lang2} is used to call \Rfunction{path.expand} at the C
level.

\begin{verbatim}
PROTECT(v = Rf_mkString("~/src/somefile.txt"));
PROTECT(fun = Rf_lang2(Rf_install("path.expand"), v));
ans = eval(fun, R_BaseEnv);
\end{verbatim}

\begin{Ex}
  Enhance the \code{nid\_alpha\_freq} function in
  \code{nidemo/src/charfreq.c} so that file names are expanded.  Do
  this by constructing a call to \Rfunction{path.expand} at the C
  level.
\end{Ex}

\end{document}

%\VignetteDepends{Biobase,IRanges,Biostrings}
%\VignetteIndexEntry{S4 System Development in Bioconductor}
%\VignettePackage{AdvancedR}

\documentclass{beamer}

\usepackage{Bioconductor}
\SweaveOpts{keep.source=TRUE}

\title{S4 System Development in Bioconductor}
\author{Patrick Aboyoun}
\institute[FHCRC]{Fred Hutchinson Cancer Research Center}
\date{20-21 May, 2010}

\begin{document}

<<setup, echo=FALSE>>=
options(width = 62)
@ 

\frame{\titlepage}

\section[Outline]{}
\frame{\tableofcontents}


\begin{frame}
  \frametitle{BioC Motivation for OOP}
  \begin{figure}
    \includegraphics[width=2.5in]{S4/garbage_in_garbage_out.png}
    \renewcommand{\figurename}{OOP}
    \caption{Minimizing inaccurate inputs \& modularizing inputs and
      outputs.}
  \end{figure}
\end{frame}


\section{Introduction}

\subsection{Object-Oriented Programming in R}

\begin{frame}[t]
  \frametitle{Two Programming Systems in \R{}}
  \begin{itemize}
    \item \R{} is an implementation of the S3 language by Chambers
      and Hastie (1992).
    \item S3 uses a \textit{``class" attribute} to mimic aspects of
      OOP.
    \item S4 is a formal OOP system.
    \item The \Rpackage{methods} package implements the S4 system
      as described in Chambers (1998) and Chambers (2008).
  \end{itemize}
  \begin{figure}
    \includegraphics[height=1.3in,width=1in]{S4/Chambers1998.jpg}
    \hspace{0.77in}%
    \includegraphics[height=1.3in,width=1in]{S4/Chambers2008.jpg}
  \end{figure}
\end{frame}


\subsection{Role of S4 in Bioconductor}

\begin{frame}[t]
  \frametitle{Main Features of Bioconductor}
\begin{block}{S4 superiority to S3 in realizing BioC features}
  \begin{itemize}
    \item The \R{} project for statistical computing
    \item Documentation and \textbf{reproducible research}
    \item Statistical and graphical \textbf{methods for genomic data}
    \item \textbf{Genomic annotations}
    \item Open source
    \item \textbf{Open development}
  \end{itemize}
\end{block}
\begin{block}{Reasons}
  \begin{itemize}
    \item Explicit representation of classes
    \item Validity checking of instances
    \item Methods registered with generics
  \end{itemize}
\end{block}
\end{frame}

\begin{frame}[t]
  \frametitle{Use of S4 in Bioconductor}
\begin{block}{Statistics on packages in BioC 2.6}
  \begin{itemize}
    \item 197 of 389 (51\%) BioC packages define S4 classes
    \item 97 use inheritance
    \begin{itemize}
      \item traditional parents: \Rclass{ExpressionSet}
        and \Rclass{eSet} from \Rpackage{Biobase}
      \item newer prolific parent: \Rclass{Sequence} from
        \Rpackage{IRanges}
      \item common off-beat parent: \Rclass{list}, an S3 type
    \end{itemize}
    \item 30 define virtual classes
    \item 14 use multiple inheritance
  \end{itemize}
\end{block}
\end{frame}


\section{S4 Basics}

\begin{frame}[t]
  \frametitle{S4 Framework}
\begin{block}{S4 Components}
  \begin{columns}[t]
    \column{0.3\textwidth}
    \textit{Class}
    \begin{itemize}
      \item is virtual?
      \item slots (properties)
      \item contains (inherits)
      \item prototype
      \item validity function
    \end{itemize}

    \column{0.3\textwidth}
    \textit{Generic Function}
    \begin{itemize}
      \item dispatch signature
      \item dispatch method
    \end{itemize}

    \column{0.3\textwidth}
    \textit{Methods{\footnotesize *}}
    \begin{itemize}
      \item signature mapping
      \item function definition
    \end{itemize}
      {\scriptsize * Grouped in methods list}
  \end{columns}
\end{block}
\begin{block}{Important differences with Java and C++}
  \begin{enumerate}
    \item Classes don't own methods.
    \item Design goal: Be ``vectorized".
      \begin{enumerate}[(a)]
        \item Class slots ideally vectors and matrices.
        \item Methods avoid unnecessary looping.
      \end{enumerate}
  \end{enumerate}
\end{block}
\end{frame}

\subsection{S4 Classes}

\begin{frame}[t]
  \frametitle{S4 Class Creation}
\begin{block}{\Rfunction{setClass} function arguments}
  \begin{itemize}
    \item \Rfunarg{Class} -- the class name.
    \item \Rfunarg{representation} -- the slot definitions.
    \item \Rfunarg{contains} -- the parent classes.
    \item \Rfunarg{prototype} -- the slot values for a default
      instance.
    \item \Rfunarg{validity} -- a function that checks instance
      validity.
  \end{itemize}
\end{block}
\begin{block}{\Rfunction{new} constructor arguments}
  \begin{itemize}
    \item \Rfunarg{Class} -- the class name.
    \item \Rfunarg{...} -- typically, slot values.
  \end{itemize}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Canonical Example in S4 (1/2)}
{\footnotesize
\begin{block}{Class definition}
<<Greeting-class, results=hide>>=
setClass("Greeting",
         representation =
         representation(phrase = "character"),
         prototype = prototype(phrase = "Hello world!"))
@
\end{block}
\begin{block}{Default instantiation}
<<Greeting-new-default>>=
new("Greeting")
@
\end{block}
\begin{block}{Customized instantiation}
<<Greeting-new-custom>>=
new("Greeting", phrase = "ciao")
@
\end{block}
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Canonical Example in S4 (2/2)}
\begin{block}{Validity method}
{\small
<<setValidity, results=hide>>=
setValidity("Greeting",
    function(object) {
        if (length(object@phrase) != 1)
            "'phrase' not a single string"
        else if (!nzchar(object@phrase))
            "'phrase' is empty"
        else
            TRUE
    })
@
}
\end{block}
\begin{block}{Invalid object instantiation}
{\small
\begin{verbatim}
> new("Greeting", phrase = "")
Error in validObject(.Object) : 
  invalid class "Greeting" object: 'phrase' is empty
\end{verbatim}
}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Creating New S4 Objects from Old}
\begin{block}{\Rfunction{initialize} function arguments}
  \begin{itemize}
    \item \Rfunarg{.Object} -- an S4 object.
    \item \Rfunarg{...} -- typically, new slot values.
  \end{itemize}
\end{block}
\begin{block}{Creation via \Rfunction{initialize}}
{\small
<<Greeting-update>>=
nametag <- new("Greeting")
nametag <- initialize(nametag, phrase = "Welcome")
nametag
@
}
\end{block}
\end{frame}


\subsection{S4 Generic Functions \& Methods}

\begin{frame}[t,fragile]
  \frametitle{S4 Generic Function \& Method Creation}
\begin{block}{\Rfunction{setGeneric} function arguments}
  \begin{itemize}
    \item \Rfunarg{name} -- the generic function name.
    \item \Rfunarg{def} -- the generic definition, typically of
      the form
      \vskip4pt
      {\footnotesize
      \verb+function(<<ARG_LIST>>) standardGeneric("<<GEN_NAME>>"))+
      }
      \vskip4pt
    \item \Rfunarg{signature} -- the method dispatch signature.
  \end{itemize}
\end{block}
\begin{block}{\Rfunction{setMethod} function arguments}
   \begin{itemize}
     \item \Rfunarg{f} -- the generic function name.
     \item \Rfunarg{signature} -- the mapping of arguments in
       dispatch signature to classes.
     \item \Rfunarg{definition} -- the method definition.
   \end{itemize}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Generic Function \& Method for Canonical Example (1/2)}
\begin{block}{Generic function definition}
{\small
<<words-generic, results=hide>>=
setGeneric("words", signature = "x",
    function(x) standardGeneric("words"))
@
}
\end{block}
\begin{block}{Method definition}
{\small
<<words-method, results=hide>>=
setMethod("words", c("x" = "Greeting"),
    function(x)
    {
        ans <- strsplit(x@phrase, "\\W")[[1L]]
        sort(unique(ans[nzchar(ans)]))
    })
@
}
\end{block}
\begin{block}{Method invocation}
{\small
<<words-use>>=
words(new("Greeting"))
@
}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Generic Function \& Method for Canonical Example (2/2)}
\begin{block}{Method definition}
{\small
<<words-method, results=hide>>=
setMethod("words", c("x" = "character"),
    function(x)
    {
        ans <- unlist(strsplit(x, "\\W"),
                      use.names = FALSE)
        sort(unique(ans[nzchar(ans)]))
    })
setMethod("words", c("x" = "Greeting"),
    function(x) callGeneric(x@phrase))
@
}
\end{block}
\begin{block}{Method invocation}
{\small
<<words-use>>=
words(new("Greeting"))
@
}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Implicit Generic Method for Canonical Example}
\begin{block}{Non-S4 generic function}
{\small
<<nchar>>=
showMethods("nchar")
@
}
\end{block}
\begin{block}{Method definition}
{\small
<<nchar-method, results=hide>>=
setMethod("nchar", c("x" = "Greeting"),
          function(x) nchar(x@phrase))
@
}
\end{block}
\begin{block}{Method invocation}
{\small
<<nchar-use>>=
nchar(new("Greeting"))
@
}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Implicit Generic Not Always Available}
\begin{block}{}
{\small
<<nzchar, eval=FALSE>>=
showMethods("nzchar")
@
\begin{verbatim}
Error in genericForPrimitive(f) : 
  methods may not be defined for primitive function
"nzchar" in this version of R
\end{verbatim}
}
\end{block}
\begin{block}{}
{\small
<<nzchar-method, eval=FALSE>>=
setMethod("nzchar", c("x" = "Greeting"),
          function(x) nzchar(x@phrase))
@
\begin{verbatim}
Error in genericForPrimitive(f) : 
  methods may not be defined for primitive function
"nzchar" in this version of R
\end{verbatim}
}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{S4 Coerce and Replace Method Creation}
\begin{block}{\Rfunction{setAs} function arguments;
  produces \Rfunction{coerce} methods}
  \begin{itemize}
    \item \Rfunarg{from} -- the old object's class.
    \item \Rfunarg{to} -- the new object's class.
    \item \Rfunarg{def} -- the method definition.
  \end{itemize}
\end{block}
\begin{block}{\Rfunction{setReplaceMethod} function;
  produces \Rfunction{"<-"} methods}
  \begin{itemize}
    \item A wrapper for \Rfunction{setMethod} that adds suffix
      \Rfunction{"<-"} to argument \Rfunarg{f}.
    \item e.g. \Rfunction{"names<-"}, usage:
      \verb|names(x) <- letters|.
  \end{itemize}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Coercion Method for Canonical Example}
\begin{block}{Method definition}
{\small
<<coercion-def>>=
setAs("Greeting", "character",
      function(from) from@phrase)
@
}
\end{block}
\begin{block}{Display coerce methods}
{\small
<<coerce-methods>>=
showMethods("coerce", classes = "Greeting")
@
}
\end{block}
\begin{block}{Perform coercion}
{\small
<<coerce-use>>=
as(new("Greeting"), "character")
@
}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Slot Accessor and Replacer in Canonical Example (1/2)}
\begin{block}{Accessor generic and method}
{\small
<<phrase-getter, results=hide>>=
setGeneric("phrase", signature = "x",
    function(x) standardGeneric("phrase"))
setMethod("phrase", "Greeting",
    function(x) x@phrase)
@
}
\end{block}
\begin{block}{Replacer generic and method}
{\small
<<phrase-setter, results=hide>>=
setGeneric("phrase<-", signature = "x",
    function(x, value) standardGeneric("phrase<-"))
setReplaceMethod("phrase", "Greeting",
    function(x, value) initialize(x, phrase = value))
@
}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Slot Accessor and Replacer in Canonical Example (2/2)}
\begin{block}{Accessor invocation}
{\small
<<Greeting-use-getter>>=
silentBob <- new("Greeting")
phrase(silentBob)
@
}
\end{block}
\begin{block}{Replacer invocation}
{\small
<<Greeting-use-replacer, eval=FALSE>>=
phrase(silentBob) <- ""
@
\begin{verbatim}
Error in validObject(.Object) : 
  invalid class "Greeting" object: 'phrase' is empty
\end{verbatim}
}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Motivation for Replacement Methods}
\begin{block}{Slot replacement methods don't validity check}
{\small
<<Greeting-bug>>=
silentBob <- new("Greeting")
silentBob@phrase <- ""
@
\begin{verbatim}
> validObject(silentBob)
Error in validObject(silentBob) : 
  invalid class "Greeting" object: 'phrase' is empty
\end{verbatim}
}
\end{block}
\begin{block}{\Rfunction{initialize} function does}
{\small
\begin{verbatim}
> initialize(silentBob, phrase = "")
Error in validObject(.Object) : 
  invalid class "Greeting" object: 'phrase' is empty
\end{verbatim}
}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Object Display in Canonical Example}
\begin{block}{\Rfunction{show} method definition}
{\small
<<show-method, results=hide>>=
setMethod("show", "Greeting",
    function(object)
    {
        cat("A ", class(object), ": \"", phrase(object),
            "\"\n", sep = "")
    })
@
}
\end{block}
\begin{block}{\Rfunction{show} method invocation}
{\small
<<show-method>>=
new("Greeting")
@
}
\end{block}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Finding Methods for an S4 Class}
\begin{block}{\Rfunction{showMethods} function wrapper}
{\small
<<s4Methods>>=
s4Methods <- function(class)
{
    methods <-
      showMethods(classes = class, printTo = FALSE)
    methods <- methods[grep("^Function:", methods)]
    sapply(strsplit(methods, " "), "[", 2)
}
@
}
\end{block}
\begin{block}{Using custom function}
{\small
<<s4Methods-use>>=
s4Methods("Greeting")
@
}
\end{block}
\end{frame}


\section{S4 Exercises}

\begin{frame}[t,fragile]
  \frametitle{S4 Classes for Exercises}
\begin{block}{Virtual Class}
{\small
<<Sample-class, results=hide>>=
setClass("Sample",
         representation("VIRTUAL",
                        description = "character"))
@
}
\end{block}
\begin{block}{Subclasses}
{\small
<<OneSample-class, results=hide>>=
setClass("OneSample", contains = "Sample",
         representation(one = "numeric"))
@
<<TwoSample-class, results=hide>>=
setClass("TwoSample", contains = "Sample",
         representation(one = "numeric",
                        two = "numeric"))
@
}
\end{block}
\end{frame}

\begin{frame}[t]
  \frametitle{S4 Exercises}
{\small
  \begin{enumerate}
    \item Create a \Rclass{PairedSample} class that inherits
      from \Rclass{TwoSample}.
      \begin{enumerate}[(a)]
        \item Same slots as \Rclass{TwoSample}.
        \item Validity method checks slots \Rfunarg{one} and
          \Rfunarg{two} to be of equal length.
      \end{enumerate}
    \item Create a \Rfunction{tTest} generic and methods using
      \Rfunction{t.test} function from the \Rpackage{stats} package.
      \begin{enumerate}[(a)]
        \item Generic signature \\
          \Rfunction{(x, alternative = c("two.sided", "less", "greater"),
                      mu = 0, conf.level = 0.95, ...)}
        \item \Rclass{OneSample} and \Rclass{PairedSample} method signature \\
          \Rfunction{(x, alternative = c("two.sided", "less", "greater"),
                      mu = 0, conf.level = 0.95)}
        \item \Rclass{TwoSample} method signature \\
          \Rfunction{(x, alternative = c("two.sided", "less", "greater"),
                      mu = 0, conf.level = 0.95, var.equal = FALSE)}
      \end{enumerate}
    \item Create \Rfunction{show} methods and any other features
      you find interesting.
  \end{enumerate}
}
\end{frame}


\section{S4 Constraints}

\subsection{Copy on Slot Modification}

\begin{frame}[t,fragile]
  \frametitle{S4 Objects Always Copied on Modification}
\begin{block}{S4 object copy-on-change}
{\small
\begin{verbatim}
> setClass("DotDash", representation =
+          representation(dot = "raw", dash = "integer"))
> aDotDash <- new("DotDash", dot = as.raw(1), dash = 1:1e8)
> system.time(aDotDash@dot <- as.raw(2))
   user  system elapsed 
  0.254   0.333   0.603 
\end{verbatim}
}
\end{block}
\begin{block}{Best practices}
  \begin{itemize}
    \item Use one \Rfunction{initialize} call instead of multiple
      \Rfunction{"@<-"}/\Rfunction{"slot<-"} calls.
    \item Vectorize (e.g. inherit from \Rpackage{IRanges}'s
      \Rclass{CompressedList} class).
  \end{itemize}
\end{block}
\end{frame}


\subsection{Object Overhead}

\begin{frame}[t,fragile]
  \frametitle{S4 Object Overhead}
\begin{block}{S4 object instantiation timing \& size}
{\small
\begin{verbatim}
> setClass("DotDash", representation =
+          representation(dot = "raw", dash = "integer"))

> system.time(dd <- lapply(1:1e4, function(i) new("DotDash")))
  user  system elapsed 
 0.740   0.003   0.745 

> print(object.size(dd), units = "Mb")
4.2 Mb
\end{verbatim}
}
\end{block}
\begin{block}{Best practice}
  \begin{itemize}
    \item Vectorize (e.g. inherit from \Rpackage{IRanges}'s
      \Rclass{CompressedList} class).
  \end{itemize}
\end{block}
\end{frame}


\subsection{Method Dispatch}

\begin{frame}[t,fragile]
  \frametitle{S4 Method Dispatch}
\begin{block}{S4 method dispatch}
{\small
\begin{verbatim}
> setClass("DotDash", representation =
+          representation(dot = "raw", dash = "integer"))
> aDotDash <- new("DotDash")
> setMethod("show", "DotDash", function(object) cat())
> system.time(lapply(1:1e4, function(i) show(aDotDash)))
   user  system elapsed 
  0.424   0.004   0.441
\end{verbatim}
}
\end{block}
\begin{block}{Best practice}
{\small
\begin{verbatim} 
> chosenFun <- selectMethod("show", "DotDash")
> system.time(lapply(1:1e4, function(i) chosenFun(aDotDash)))
   user  system elapsed 
  0.084   0.001   0.094 
\end{verbatim}
}
\end{block}
\end{frame}


\section{S4 Case Studies}

\subsection{Slot-Oriented Virtual Class (eSet)}

\begin{frame}[t,fragile]
  \frametitle{Slot-Oriented Virtual Class (eSet)}
  \begin{columns}[t]
    \column{0.5\textwidth}
    \Rpackage{Biobase}'s \Rclass{eSet}
{\scriptsize
<<Biobase, results=hide>>=
library(Biobase)
@
<<options-set, echo=FALSE>>=
options(width=35)
@
<<eSet>>=
isVirtualClass("eSet")
getSlots("eSet")
@
<<options-reset, echo=FALSE>>=
options(width=62)
@
}

    \column{0.5\textwidth}
\Rpackage{limma}'s \Rclass{MAList}
{\scriptsize
<<limma, results=hide>>=
library(limma)
@
<<MAList>>=
isVirtualClass("MAList")
getSlots("MAList")
@
}
  \end{columns}
\end{frame}

\subsection{Method-Oriented Virtual Class (Sequence)}

\begin{frame}[t,fragile]
  \frametitle{Method-Oriented Virtual Class (Sequence)}
    \Rpackage{IRanges}'s \Rclass{Sequence}
{\footnotesize
<<IRanges, results=hide>>=
library(IRanges)
@
<<Sequence>>=
isVirtualClass("Sequence")
getSlots("Sequence")
getSlots("Rle")
length(s4Methods("Sequence"))
head(s4Methods("Sequence"), 8)
@
}
\end{frame}

\begin{frame}[t,fragile]
  \frametitle{Method-Oriented Virtual Class (Sequence)}
\begin{block}{\Rclass{Sequence} subclass defines}
  \Rfunction{"["}, \Rfunction{c}, \Rfunction{length},
  \Rfunction{window}, \Rfunction{seqselect}, \Rfunction{"seqselect<-"}
\end{block}
\begin{block}{\Rclass{Sequence} subclass inherits}
    \Rfunction{head}, \Rfunction{tail}, \Rfunction{append},
    \Rfunction{subset}, \Rfunction{rep}, \Rfunction{rev} \footnotesize{(optimize?)},
    \Rfunction{"window<-"}, \Rfunction{"[<-"}
{\footnotesize
\begin{verbatim}
setMethod("head", "Sequence",
    function(x, n = 6L, ...)
    {
        stopifnot(length(n) == 1L)
        if (n < 0L)
            n <- max(length(x) + n, 0L)
        else
            n <- min(n, length(x))
        if (n == 0L)
            x[integer(0)]
        else
            window(x, 1L, n)
    })
\end{verbatim}
}
\end{block}
\end{frame}

\subsection{Multiple Inheritance \& Vectorization (CompressedIRangesList)}

\begin{frame}[t,fragile]
  \frametitle{Multiple Inheritance \& Vectorization (CompressedIRangesList)}
\begin{block}{\Rclass{CompressedIRangesList}}
{\small
\begin{verbatim}
setClass("CompressedIRangesList",
         prototype = prototype(elementType = "IRanges",
                               unlistData = new("IRanges")),
         contains = c("IRangesList", "CompressedList"))
\end{verbatim}
}
\end{block}
\begin{block}{\Rpackage{IRanges}'s \Rclass{List} paradigm}
  \begin{itemize}
    \item \Rclass{IRangesList} -- a method-oriented virtual class
    \item \Rclass{CompressedList} -- a slot-oriented virtual class
    \item \Rclass{SimpleIRangesList} -- a sibling class to 
      \Rclass{CompressedIRangesList}
  \end{itemize}
\end{block}
\end{frame}

\subsection{Build or Reuse? (CompresssedIRangesList)}

\begin{frame}[t,fragile]
  \frametitle{Build or Reuse? (CompresssedIRangesList)}
  \begin{columns}[t]
    \column{0.5\textwidth}
    \Rpackage{IRanges}'s \Rclass{CompressedIRangesList}
{\scriptsize
<<options-set, echo=FALSE>>=
options(width=35)
@
<<IRanges, results=hide>>=
library(IRanges)
@
<<CompressedIRangesList>>=
is(new("CompressedIRangesList"))
length(s4Methods("RangesList"))
head(s4Methods("RangesList"), 8)
@
}

    \column{0.5\textwidth}
\Rpackage{Biostrings}'s \Rclass{MIndex}
{\scriptsize
<<Biostrings, results=hide>>=
library(Biostrings)
@
<<MIndex>>=
isVirtualClass("MIndex")
s4Methods("MIndex")
s4Methods("ByPos_MIndex")
@
<<options-reset, echo=FALSE>>=
options(width=62)
@
}
  \end{columns}
\end{frame}

\subsection{Class Union \& Group Generic (Rle)}

\begin{frame}[t,fragile]
  \frametitle{Class Union \& Group Generic (Rle)}
  \Rpackage{IRanges}'s \Rclass{Rle}
{\footnotesize
\begin{verbatim}
setClassUnion("vectorORfactor", c("vector", "factor"))

setClass("Rle", contains = "Sequence")
         representation(values = "vectorORfactor",
                        lengths = "integer"),
         <<REMAINING DEFINITION>>)

setMethod("Summary", "Rle",
    function(x, ..., na.rm = FALSE)
        switch(.Generic,
               all =, any =, min =, max =, range =
               callGeneric(runValue(x), ..., na.rm = na.rm),
               sum = sum(runValue(x) * runLength(x), ...,
                         na.rm = na.rm),
               prod = prod(runValue(x) ^ runLength(x), ...,
                           na.rm = na.rm)))
\end{verbatim}
}
\end{frame}


\section{Resources}

\begin{frame}{Resources}
  \begin{block}{Books}
{\small
    \begin{itemize}
      \item John M. Chambers.
        \textit{Software for Data Analysis: Programming with R}.
        Springer, New York, 2008. ISBN-13 978-0387759357.
      \item Robert Gentleman. \textit{R Programming for Bioinformatics}.
        Chapman \& Hall/CRC, New York, 2008. ISBN-13 978-1420063677.
    \end{itemize}
}
  \end{block}
  \begin{block}{Documents on the Web}
{\small
    \begin{itemize}
      \item John M. Chambers. ``How S4 Methods Work", \\
        \url{http://developer.r-project.org/howMethodsWork.pdf}
      \item Friedrich Leisch, ``S4 Classes and Methods", \\
        \url{http://www.ci.tuwien.ac.at/Conferences/useR-2004/Keynotes/Leisch.pdf}
      \item ``S4 Classes in 15 pages, more or less", \\
        \url{http://www.stat.auckland.ac.nz/S-Workshop/Gentleman/S4Objects.pdf}
    \end{itemize}
}
  \end{block}
\end{frame}

\end{document}

%\VignetteDepends{codetoolsBioC, RUnit, GenomicFeatures}
%\VignetteIndexEntry{Building Packages}
%\VignettePackage{AdvancedR}


\documentclass{beamer}
%\usepackage{Sweave}
\usepackage{Bioconductor}
\SweaveOpts{keep.source=TRUE}

\title{Building Packages}
\author{Chao-Jen Wong, Nishant Gopalakrishnan, Marc Carson, and Patrick Aboyoun}
\institute[FHCRC]{Fred Hutchinson Cancer Research Center}
\date{20-21 May, 2010}


\begin{document}

<<setup, echo=FALSE>>=
options(width = 40)
@ 

\frame{\titlepage}

\section[Outline]{}
\frame{\tableofcontents}


\section{R Packages}
\subsection{Package Concept}
\begin{frame}{Package Concept}
  \begin{block}{\texttt{R} packages}
    A collection of source code allows the user to attach
    to R session when calling \Rfunction{library()} or \Rfunction{require()}.
  \end{block}

  \begin{block}{Why write a package?}
    \begin{itemize}
      \item Better way to organize your code.
      \item Ability to share software as \texttt{R} packages.
      \item Provide reliable access.
      \item Provide communication channel between the users and authors.
      %\item Control what other packages you use and what you want to make
      %  public (via namespaces).
    \end{itemize}
  \end{block}
\end{frame}

\subsection{Creating R packages}
\begin{frame}[fragile]{Creating a Package}
  \begin{block}{Initialize a new package}
    % do demo on R session
<<skeleton, eval=FALSE>>=
package.skeleton()
@
    
  \end{block}
  
  \begin{block}{Source package}
    \begin{itemize}
      \item Special files
        \begin{itemize}
          \item Essential: \alert{\texttt{DESCRIPTION}} and
            \alert{\texttt{NAMESPACE}}. 
          \item Others: \texttt{configure}, \texttt{LICENSE},
            \texttt{COPYING}, \texttt{INDEX}  and \texttt{NEWS}. 
        \end{itemize}
      \item Subdirectories containing source code, documentation and other
        material.
    \end{itemize}
  \end{block}
% DESCRIPTION: contains basic information about the package
% NAMESPACE: Control what other packages you use and what you want to make
%  public (via namespaces).
  
\end{frame}

\begin{frame}[fragile]{Creating a Package}
  \begin{block}{Subdirectories}
    \vspace{0.2 in}
      \begin{tabular}{|l|l|}
        \hline
        {\bf Directory}& {\bf Content} \\ \hline
        \texttt{R}     & source files (.R) \\ 
        \hline
        \texttt{data}  & files of data objects to be loaded by
                         \Rfunction{data()}  \\ \hline
        \texttt{inst}  & content copied to the installed packages' directory \\
                       & \texttt{doc} -- Sweave document (.Rnw) \\
                       & \texttt{extdata} -- misc. data objects (ASCII) \\
                       & \texttt{unitTest} -- unit testing functions \\
                         \hline
        \texttt{man}   & \Robject{Rd} documentation \\ 
        \hline
        \texttt{src}   & source code in \texttt{C}, \texttt{FORTRAN} or
                       \texttt{C++} \\  \hline 
        \texttt{tests} & test code in \R{} \\ 
        \hline
    \end{tabular}
  \end{block}
\end{frame}


\subsection{Package Tools}
\begin{frame}[fragile]{Package Tools}
  \begin{block}{\texttt{R} shell tools}
    \begin{itemize}
      \item Used to manage packages (build, check and etc.).
      \item Can be accessed from a command shell.
    \end{itemize}
  \end{block}

  \begin{block}{Shell commends}  
    Take the form: \texttt{R CMD} \textit{operation}
    \begin{verbatim}
      $R CMD build package
      $R CMD check package  
      $R CMD check --help
      $R CMD INSTALL package
      $R CMD REMOVE package
      ...
    \end{verbatim}
  \end{block}
\end{frame}

%------------------------- section 2
\section{Package Dependencies and Namespaces}
\begin{frame}[fragile, shrink=18]{Dependencies in DESCRIPTION}
  \begin{block}{The \texttt{DESCRIPTION} file}
    \begin{verbatim}
Package: affy
Version: 1.25.2
Title: Methods for Affymetrix Oligonucleotide Arrays
Author: Rafael A. Irizarry <rafa@jhu.edu>, Laurent Gautier
        ...
Maintainer: Rafael A. Irizarry <rafa@jhu.edu>
Depends: R (>= 2.8.0), Biobase (>= 2.5.5)
Imports: affyio (>= 1.13.3), Biobase (>= 2.5.5), graphics, 
         grDevices, methods, preprocessCore, stats, utils
Suggests: tkWidgets (>= 1.19.0), affydata
Description: The package contains functions for exploratory
             ...
License: LGPL (>= 2.0)
Collate: ProgressBarText.R ppset.ttest.R ppsetApply.R expressoWidget.R
        getCDFenv.R AffyRNAdeg.R avdiff.R barplot.ProbeSet.R ...

     \end{verbatim}
  \end{block}
  
\end{frame}

\begin{frame}[fragile]{Dependencies in DESCRIPTION}
%why is it important
  \begin{itemize}
    \item Declare what packages are required to run your package.
    \item Clarify the relationship between your package and other packages.
    \item Give clear and reliable definition of the package's behavior
      (namespaces).
  \end{itemize}
\end{frame}

\begin{frame}[fragile]{Dependencies in DESCRIPTION}
      % explain the attach/load mechanism
      \begin{block}{Depends}

          %\item Packages in the Depends field are attached to the search path
          %  prior to the package is loaded
           Packages expected to be attached 

      \end{block}
      \begin{block}{Imports}
        \begin{itemize}
          \item Only a few functions or objects are used by this package.
          \item Not necessarily needed to be attached.
          \item Avoid the cost in time and space of accessing the unused
            functions. 
        \end{itemize}
      \end{block}

  \begin{block}{Suggests}
    \begin{itemize}
      \item Used in examples or vignettes.
      \item Introduce special functionality. % example: having require() in
                                % your package
    \end{itemize}
  \end{block}

\end{frame}


\begin{frame}[fragile]{Namespace}
  \begin{block}{Why give your package a namespace}
    \begin{itemize}
      \item Avoid conflicts and confusion from multiple functions (from
        attached packages) with the same names.
        % result could be potentially disastrous
      % \item Clarify package dependencies.
      \item Control what are public (exported) and private. 
      %\item More efficient loading of the package.
        
    \end{itemize}
  \end{block}
  
\end{frame}

% Namespace mechanism
\begin{frame}[fragile]{Namespace}
  
  \begin{itemize}
    \item Declare in the \texttt{NAMESPACE} file. 
    \item Required being explicit about what is exported and imported.
    \item 'import' -- entire package or specific objects, classes and methods.
      \begin{verbatim}
     import(Biobase)
or
     importFrom(Biobase, openVignettes)
       \end{verbatim}
    \item 'export' -- explicit list of objects, methods and classes.
      \begin{verbatim}
     exportPattern("^[^\\.]")
     export(...)
     exportClass(...)
     exportMethods(...)
       \end{verbatim}
      
    \item Sealed once the package is installed. 
      Non-exported functions can be addressed by the \Rfunction{:::} operator. 
  \end{itemize}
  
  % case study? show good example: GenomicFeatures
  % packages both in Imports and Depends fields?
  
\end{frame}

% codetoolsBioc
\begin{frame}[fragile]{Useful Tool: codetoolsBioC}
<<codetoolsBioC>>=
library(codetoolsBioC)
ls(2)
@ 
\begin{block}{writeNamespaceImports}
  Writes imports statements that can be included in a package's
  \texttt{NAMESPACE} file.
\end{block}
<<use writeNamespaceImports, eval=FALSE>>=
library(GenomicFeatures)
writeNamespaceImports("GenomicFeatures")
@ 

\end{frame}


%-----------------------------------------------

%%Quality of code has to be constantly verified
%% especially true for interpreted languages like R
%% where there is no compiler checking  
%Isolate each part of the program 
%show that the individual parts are correct.  
%Finds problems early in the developmental cycle

% provided by RUnit
\section{Unit Testing}
\begin{frame}[fragile, shrink=10]{What is a unit test?}
 \vspace{0.5 in}

  \begin{columns}
    \column{0.5\textwidth}
    A function myFun
    \begin{verbatim}
library(RUnit)

myFun <- function(a) {
  # input checking
  if(!is.numeric(a))
    stop("'a' should be of 
         type 'numeric(1)'")
  if(length(a) != 1)
    stop("'a' should be of 
            length 1")

  # calc factorial
  factorial(a)
}
    \end{verbatim}

    \column{0.5\textwidth}
    \vspace{0.1 in}
    Unit test for myFun
      \begin{verbatim}
test_myFun <- function() {
  target <- 6
  current <- myFun(3)
  checkIdentical(target,current)
                
  checkException(myFun("A"))

  checkException(myFun(1:8))
}
      \end{verbatim}
  \end{columns}
\end{frame}

%-----------------------------------------------
% facilitates code changes/refactoring -  I better not touch this
%% piece of code 
%% testing parts of the program first and then sum of its parts
%% makes integration easier
%% test cases become a living documentation of the system
\begin{frame}[fragile]{ Why Unit tests ?}
\begin{itemize}
\item Interface specification
\item Ensures code correctness, e.g., when \R{} changes
\item Allows refactoring without breaking existing code
\item Encourages writing simple, working code chunks that can be
  integrated into larger components
\item Encourages collaboration -- tests describe what is supposed to
  happen
\item Helps describe bugs -- `this test fails'
\item Documentation for developer -- what code is intended to do
\end{itemize}
\end{frame}

%-----------------------------------------------

\begin{frame}[fragile]{The \Rpackage{RUnit} package}
    \begin{itemize} 
      \item Framework for test case execution
        \begin{itemize}
            \item create a series of test functions
            \item define a test suite (defineTestSuite)
            \item run the tests (runTestSuite)
            \item summarize results (printTextProtocol, printHTMLProtocol)
        \end{itemize}
      % the last three steps can be accomplished by writeRUnitRunner
      \item Hint: use \Rfunction{writeRUnitRunner} from the
        \Rpackage{codetoolsBioC} package

      %\item Tools for code coverage inspection
  \end{itemize}
\end{frame}

%-----------------------------------------------
%%Demonstrate by going through the folders of the GenomicFeatures package

\begin{frame}[fragile]{Adding Unit tests to your package}
\begin{itemize}
\item Create test functions 
   \begin{itemize}
    \item save in inst/unitTests folder of your package
    \end{itemize}
    %demo: open GenomicFeatures/inst/unitTest, show how it looks like...
\item Function to create test suite, run tests, summarize results
  % define your test suite, run the unitTest and summarize results...
    \begin{itemize}
        \item use \Rfunction{writeRUnitRunner} to create the file
          containing the \Rfunction{.test} function
        \item save in R folder of your package 
    \end{itemize} % just like internal private functions
\item Function to call the \Rfunction{.test} function
    \begin{itemize}
        \item save in the tests folder of your package
        % allows R CMD check to run .test or pkg:::.test
    \end{itemize}
 
\item Add \Rpackage{RUnit} to the Suggests field in DESCRIPTION
\end{itemize}
\end{frame}

%-----------------------------------------------
%% say how the .test is an internal function, useful to access
%% and test code after making some changes to your package without
%% running R CMD check.     USE ::: to access an internal function

% avoid calling up R CMD check...
\begin{frame}[fragile]{Running a unit tests}
  % show nidemo demo on my screen
  
  % how to run with R CMD check
% an alternative way to run unit testing for your package ...
% if don't want to run R CMD check, just want to run unit testing
<<nidemo-demo, eval=FALSE>>=
library(nidemo)
nidemo:::.test()
@   
\end{frame}

%-----------------------------------------------

%% expections, .Rd, vignette, Sweave, Stangle,
\section{Documentation}

\begin{frame}
  \frametitle{Documentation Types}
\begin{block}{Manual pages}
  \begin{itemize}
    \item Reference pages for \R{} objects (functions, data sets, etc.)
    \item Written in ``R documentation" (Rd) format
    \item Thoroughly checked during R CMD check
    \item Templates created by \Rfunction{prompt*} family of functions
  \end{itemize}
\end{block}
\begin{block}{Vignettes}
  \begin{itemize}
    \item A task-oriented description of package functionality
    \item Contain simple "HowTo"s that are built with the package
    \item Written in Sweave (.Rnw) format, which integrates R code into
      \LaTeX{} documents
    \item Required component of a Bioconductor package
  \end{itemize}
\end{block}
  Details provided in \textit{Writing R Extensions} manual.
\end{frame}

\subsection{Manual Pages}

%-----------------------------------------------
\begin{frame}[fragile]
  \frametitle{Manual Pages (A Simple Example)}
{\small
\begin{verbatim}
\name{name}
\alias{alternate name}
\title{name of manual page}
\description{Brief description of what this does.}
\usage{
  myfun(arg1, arg2 = FALSE)
}
\arguments{
  \item{arg1}{\code{arg1} is required}
  \item{arg2}{\code{arg2} is optional}
}
\details{Important details on how it does it.}
\value{Return type}
\seealso{\code{\link[pkg:pkgfun]{pkgfun}}}
\author{Your name here}
\examples{## R code to demo this}
\keyword{names from KEYWORDS file in R doc dir}
\end{verbatim}
}
\end{frame}

%-----------------------------------------------
\begin{frame}
  \frametitle{Manual Pages (Tips)}
  \begin{itemize}
    \item Flip through ``Writing R documentation files" chapter of
      \textit{Writing R Extensions} manual
    \item Change manual page when when underlying \R{} object changes
    \item Make examples run fast and be robust to changes in
      annotations and web resources
    \item Run R CMD check on modified packages
  \end{itemize}
\end{frame}


\subsection{Vignettes}

%-----------------------------------------------
\begin{frame}[fragile]
  \frametitle{Vignette (Skeleton)}
{\footnotesize
\begin{verbatim}
%\VignetteIndexEntry{Descriptive Title}
%\VignetteKeywords{words}
%\VignettePackage{Package Name}

\documentclass[11pt]{article}

\usepackagege{Sweave}

\newcommand{\Rfunction}[1]{{\texttt{#1}}}
\newcommand{\Robject}[1]{{\texttt{#1}}}
\newcommand{\Rpackage}[1]{{\textit{#1}}}
\newcommand{\Rclass}[1]{{\textit{#1}}}

\title{Descriptive Title}
\author{your name}
 \SweaveOpts{keep.source=TRUE}

\begin{document}
\maketitle

\end{document}
\end{verbatim}
}
\end{frame}

%-----------------------------------------------
\begin{frame}[fragile]
  \frametitle{Vignette (Body)}
{\small
\begin{verbatim}
\begin{document}
\maketitle

\section{Introduction}
The \Rpackage{foo} is great.

\subsection{Getting Started}
First load the \Rpackage{foo} package and then execute
function \Rfunction{foo}.

 <<code-block>>=
 library(foo)
 foo()
 @

\end{document}
\end{verbatim}
}
\end{frame}

%-----------------------------------------------
\begin{frame}[fragile]
  \frametitle{Vignette (Code Blocks)}
{\small
\begin{verbatim}
 <<UnevaluatedCode, eval=FALSE>>=
 longRunningFunction(bigDataObject)
 @
 <<UnseenCodeAndOutput, echo=FALSE>>=
 options(width = 60)
 @
 <<UnseenMessages, results=hide>>=
 library(Biobase)
 @
 <<IncludeGraphic, fig=TRUE>>=
 plot(1:10)
 @
 <<KeepMyFormat, keep.source=TRUE>>=
 loveMyFormat(arg1 = "first",
              arg2 = "second")
 @
\end{verbatim}
}
\end{frame}

%-----------------------------------------------
\begin{frame}[t,fragile]
  \frametitle{Sweave and Stangle Commands}
  \Rfunction{Sweave} -- creates a post-(code block)-processed \LaTeX{} file \\
  \Rfunction{Stangle} -- creates an R script from code blocks \\
\begin{block}{R commands}
{\small
<<code-block,eval=FALSE>>=
library(tools)
Sweave("foo.Rnw")
texi2dvi("foo.tex", pdf=TRUE, clean=TRUE)
Stangle("foo.Rnw")
@
}
\end{block}
\begin{block}{Shell commands}
{\small
\begin{verbatim}
  R CMD Sweave foo.Rnw
  R CMD texi2dvi --pdf --clean foo.tex
  R CMD Stangle foo.Rnw
\end{verbatim}
}
\end{block}
\end{frame}


%-----------------------------------------------

%----------- Nishant's input -------------
\section{Tools of the trade}

\subsection{Version Control}
\begin{frame}[fragile]{Need for Version Control}
Problems
  \begin{itemize}
   \item Projects consist of multiple files
   \item We add/remove/change content
   \item Multiple people editing same file -> merge changes
   \item Multiple machines/operating systems -> merge changes
   \item Go back to a previous snapshot
  \end{itemize}

The wrong way
  \begin{itemize}
    \item proj1.R, proj2.R, proj3.R
    \item User managed backups
  \end{itemize}
\end{frame}

%-----------------------------------------------
% Distributed vs. Centralized Version Control
% Distributed vc: clients hosts the repositories, merge based on what?
\begin{frame}[fragile]{Version control software}
\begin{itemize}
   \item svn % centralized server: has a central server that host the repository
   \item Mercurial % distributed
   \item git % distributed
   \end{itemize}
\end{frame}

%-----------------------------------------------

\begin{frame}[fragile]{Bioconductor svn}
\begin{itemize}
\item Devel Branch
    \begin{itemize}
        \item \url{https://hedgehog.fhcrc.org/bioconductor/trunk/madman/Rpacks}
    \end{itemize}
\item 2.6 Release Branch
    \begin{itemize}
        \item \url{https://hedgehog.fhcrc.org/bioconductor/branches/RELEASE\_2\_6/
              madman/Rpacks}
    \end{itemize}
\item username:readonly password:readonly
\end{itemize}

Reference Book:\textit{ Version Control with Subversion}
\url{http://svnbook.red-bean.com/}
\end{frame}

%-----------------------------------------------

\begin{frame}[fragile]{Useful svn commands: svn checkout}
svn co https://hedgehog.fhcrc.org/bioconductor/trunk/madman/Rpacks/
BiocCaseStudies/ --username readonly --password readonly
    \begin{figure}
    \includegraphics[width=3in]{packs/svnCo.png}
    \end{figure}
\end{frame}

%-----------------------------------------------

\begin{frame}[fragile]{Useful svn commands: svn log}
svn log NAMESPACE | more
    \begin{figure}
    \includegraphics[width=3.5in]{packs/svnLog.png}
    \end{figure}

\begin{itemize}
\item Logs are useful only if useful commit messages are provided.
\item Commit once conceptual change at a time.
\end{itemize}
\end{frame}

%-----------------------------------------------

%\begin{frame}[fragile]{Useful svn commands: svn update}
%   svn update -r28929 NAMESPACE
%    \begin{figure}
%    \includegraphics[width=3.5in]{packs/svnUpdate.png}
%    \end{figure}
%\end{frame}

%-----------------------------------------------
% + : added; -: removed
%\begin{frame}[fragile]{Useful svn commands: svn diff}
%    svn diff NAMESPACE -r29576 
%    \begin{figure}
%    \includegraphics[width=3.5in]{packs/svnDiff.png}
%    \end{figure}
%\end{frame}

%-----------------------------------------------
%
%\begin{frame}[fragile]{Useful svn commands: svn export}
%    svn export BiocCaseStudies/ \~/proj/packages/BiocCaseStudies --force
%    \begin{figure}
%    \includegraphics[width=3.5in]{packs/svnExport.png}
%    \end{figure}
%\end{frame}

%-----------------------------------------------

\begin{frame}[fragile]{Useful svn commands}
\begin{itemize}
  \item svn checkout
  \item svn add
  \item svn checkin
  \item svn update
  \item svn status
  \item svn log -v 
  \item ...
\end{itemize}
\end{frame}

%-----------------------------------------------

\subsection{Efficient Editing}

\begin{frame}[fragile]{Efficient Editing}
  \framesubtitle{Editing from the command line}
\begin{itemize}
\item history()
\item savehistory("foo")
\item loadhistory("foo")
\item reverse search on unix using \texttt{Ctrl-R}
\end{itemize}
\end{frame}

%-----------------------------------------------
% R-mode

\begin{frame}[fragile]{Code editors}
    \begin{itemize}
        \item Eclipse(StatET) \url{http://www.walware.de/goto/statet}
        \item Emacs(ESS) \url{http://ess.r-project.org/}
        \item vim(Vim-R-plugin2) \url{http://www.vim.org/scripts/script.php?script_id=2628}
        \item Tinn-R
        \item Notepad++(NppToR) \url{http://sourceforge.net/projects/npptor/}
    \end{itemize}
Advantages
\begin{itemize}
    \item{syntax highlighting}
    \item{auto indent code}
    \item{send code/functions to R console}
\end{itemize}
\end{frame}

\begin{frame}[fragile]{Efficient work flows}
  Editing without building documentation or configure
  \begin{verbatim}
    R CMD check --no-vigenttes --no-examples pkgs
    R CMD INTSALL --no-docs pkgs
    R CMD INSTALL --no-configure pkgs
    R CMD INSTALL --help
  \end{verbatim}
\end{frame}
%-----------------------------------------------

%\begin{frame}[fragile]{Accessing functions not available in the namespace}
%\begin{itemize}
%\item :: operator to access functions that are exported from a package
%namespace 
%\item ::: operator to access internal functions not exported from the package 
%namespace
%\end{itemize}
%\end{frame}

%-----------------------------------------------
% explain what is .Rfile

% example: sourcing biocLite.R
\begin{frame}[fragile, shrink=10]{.Rprofile}
%\begin{verbatim}
%dir.create(Sys.getenv("R_LIBS_USER"),
%                   recursive = TRUE,
%                   showWarnings = FALSE)
%
%options(repos="http://cran.fhcrc.org")

\begin{verbatim}

.First <- function() {cat("\n Hello! \n\n")}

if (interactive()) {
    tryCatch({
         source("http://bioconductor.org/biocLite.R")
    }, error=function(e) invisible(NULL),
       warning=function(w) message("Not connected to the net"))
}

reload_pkg <- function(p) {
    detach(paste("package", p, sep = ":"), unload = TRUE,
            character.only = TRUE)
    library(p, character.only = TRUE)
}

\end{verbatim}
\end{frame}

%-----------------------------------------------
% detach your package and reload it again
% useful when you change your package and want to re-install
%\begin{frame}[fragile]{.Rprofile - reload an R package}
%\begin{verbatim}
%reload_pkg <- function(p) {
%    detach(paste("package", p, sep = ":"), unload = TRUE,
%            character.only = TRUE)
%    library(p, character.only = TRUE)
%}
%\end{verbatim}
%\end{frame}
 
%-----------------------------------------------
\section{Resources}

\begin{frame}{Resources}
  \begin{itemize}
    \item John Chambers. \emph{Software for Data Analysis}.  Springer, New
      York, 2008. 
    \item \emph{Writing R Extensions} manual, \\
      \url{http://cran.r-project.org/doc/manuals/R-exts.html}
    \item \emph{Version Control with Subversion}, \\
      \url{http://svnbook.red-bean.com/} 
    \item \emph{Sweave User Manual}, \\
      \url{http://www.stat.uni-muenchen.de/~leisch/Sweave}
  \end{itemize}
\end{frame}


\end{document}

%\VignetteDepends{}
%\VignetteIndexEntry{}
%\VignettePackage{AdvancedR}

\documentclass{beamer}

\usepackage{Bioconductor}
\SweaveOpts{keep.source=TRUE}

\title{Presentation title}
\author{Author}
\institute[FHCRC]{Fred Hutchinson Cancer Research Center}
\date{20-21 May, 2010}

\begin{document}

<<setup, echo=FALSE>>=
options(width = 40)
@ 

\frame{\titlepage}

\section[Outline]{}
\frame{\tableofcontents}

\section{Introduction}
\begin{frame}{frame title}
\end{frame}

\begin{frame}[fragile]{Subsetting and non-specific filtering}
<<code-block>>=
## use [fragile] in frames with Sweave
x <- 1:10
@ 
\end{frame}

\section{Resources}

\begin{frame}{Resources}
  %% Include key resources -- urls, books, ...
\end{frame}

\end{document}

%\VignetteDepends{}
%\VignetteIndexEntry{Native Interfaces}
%\VignettePackage{AdvancedR}

%% \documentclass[notesonly]{beamer}
%% \documentclass[handout,xcolor=pdftex,dvipsnames,table]{beamer}
\documentclass{beamer}

\usepackage{Bioconductor}
\SweaveOpts{keep.source=TRUE}

\title{Native Interfaces for \R{}}
\author{Seth Falcon}
\institute[FHCRC]{Fred Hutchinson Cancer Research Center}
\date{20-21 May, 2010}

\begin{document}

<<setup, echo=FALSE>>=
options(width = 40)
@

\frame{\titlepage}

\section{The .Call Native Interface}

\begin{frame}[fragile]{\code{which} as implemented in R prior to R-2.11}


\begin{verbatim}
which <- function(x) {
    seq_along(x)[x & !is.na(x)]
}
\end{verbatim}
\only<2>{

\begin{enumerate}
\item \code{is.na}
\item \code{!}
\item \code{\&}
\item \code{seq\_along}
\item \code{[}
\end{enumerate}
}

\note{
  How many passes are made through the input vector?

  Thanks to Patrick for the example

  Each operation scans through length(x) items and makes a copy

  It is the copies that can hurt performance
}

\end{frame}

\begin{frame}[fragile]{\code{which} in C}
\begin{verbatim}
 1 SEXP nid_which(SEXP v) {
 2     SEXP ans;
 3     int i, j = 0, len = Rf_length(v), *buf, *tf;
 4     buf = (int *) R_alloc(len, sizeof(int));
 5     tf = LOGICAL(v);
 6     for (i = 0; i < len; i++) {
 7         if (tf[i] == TRUE) buf[j] = i + 1; j++;
 8     }
 9     ans = Rf_allocVector(INTSXP, j);
10     memcpy(INTEGER(ans), buf, sizeof(int) * j);
11     return ans;
}
\end{verbatim}
\note{Make a single pass, but allocate twice}
\end{frame}

\begin{frame}{\code{which} is now 10x faster}
  \code{system.time(which(v))}
  \vskip 1cm

  \begin{tabular}{lll}
    R Version & System time & Elapsed time \\ \hline
    R-2.10  & 0.018  & 0.485 \\
    R-2.11  & 0.001  & 0.052
  \end{tabular}

  \vskip 1cm
  v is a logical vector with 10 million elements

  \note{10x is a good goal to bother with C}
\end{frame}


\begin{frame}{Making use of existing code}
  \begin{columns}
    \column{0.5\textwidth}
    Access algorithms
    \begin{itemize}
    \item RBGL
    \item RCurl
    \item Rsamtools
    \end{itemize}

    \column{0.5\textwidth}
    Interface to other systems
      \begin{itemize}
      \item RSQLite
      \item netcdf
      \item SJava
      \end{itemize}
  \end{columns}

  \note{
    LAZY in a good way

    Interfaces use R external pointers and finalizers
  }
\end{frame}

\begin{frame}[fragile]{Review of C}

\begin{semiverbatim}
#include <stdio.h>
double \alert{_nid_avg}(int *data, int len) \{
    int i;
    double ans = 0.0;
    for (i = 0; i < len; i++) \{
      ans += data[i];
    \}
    return ans / len;
\}
main() \{
    int ex_data[5] = \{1, 2, 3, 4, 5\};
    double m = _nid_avg(ex_data, 5);
    printf("%f\\n", m);
\}
\end{semiverbatim}
\note{What does this function do?}
\end{frame}

\begin{frame}{The .Call interface}
  \begin{figure}
    \includegraphics[width=4in]{nativeI/dot-call-summary}
  \end{figure}

  \note{
    Maximum control of conversion and copying

    Requires R headers, dealing with R objects in C

    Seamless intregration into R

    Safer and more powerful than .C
  }
\end{frame}

\begin{frame}{Symbolic Expressions (SEXPs)}
  \begin{itemize}
  \item The SEXP is R's fundamental data type at the C-level
  \item SEXP is short for \textit{symbolic expression} and is borrowed
    from Lisp
  \item History at \url{http://en.wikipedia.org/wiki/S-expression}
  \end{itemize}
  \note{These details help understand how to call R functions from C}
\end{frame}

\begin{frame}{.Call Start to Finish Demo}
  Demo
\end{frame}

\begin{frame}[fragile]{.Call Disection}

  {\LARGE R}

\begin{verbatim}
# R/somefile.R
avg <- function(x) .Call(.nid_avg, x)
# NAMESPACE
useDynLib("yourPackage", .nid_avg = nid_avg)
\end{verbatim}

\medskip

  {\LARGE C}

\begin{semiverbatim}
/* src/some.c */
#include <Rinternals.h>
\alert{SEXP} nid_avg(\alert{SEXP} data) \{ ... INTEGER(data) ... \}
\end{semiverbatim}

\note{The useDynLib call is one form of function registration}
\end{frame}

\begin{frame}[fragile]{.Call C function}
\begin{semiverbatim}
\alert<1>{#include <Rinternals.h>}

\alert<2>{SEXP nid_avg(SEXP data)}
\{
    SEXP ans;
    \alert<3>{double v = _nid_avg(INTEGER(data), Rf_length(data));}
    \alert<4,6>{PROTECT(ans = Rf_allocVector(REALSXP, 1));}
    \alert<5>{REAL(ans)[0] = v;}
    \alert<6>{UNPROTECT(1);}
    return ans;
    \alert<7>{/* shortcut: return Rf_ScalarReal(v); */}
\}
\end{semiverbatim}

\note{
  Call same average function shown before as helper

  Matched PROTECT/UNPROTECT
}
\end{frame}

\begin{frame}{Function Registration}
  \begin{itemize}
  \item In NAMESPACE
  \item In C via \code{R\_CallMethodDef} (See
    \code{ShortRead/src/R\_init\_ShortRead.c} for a nice example.
  \end{itemize}
  \note{
    Benefit of R\_CallMethodDef is arity checking

    NAMESPACE approach a good compromise to get started

    Can avoid reg entirely, but .Call not as nice
  }
\end{frame}

\section{R types at the C-level}

\begin{frame}{Just one thing to learn}

  \begin{itemize}
  \item {\LARGE Everything is a SEXP}
  \item But there are many different types of SEXPs
  \item INTSXP, REALSXP, STRSXP, LGLSXP, VECSXP, and more.
  \end{itemize}
\end{frame}

\begin{frame}{What's a SEXP?}
  \begin{figure}
    \includegraphics{nativeI/sexp-diagram}
  \end{figure}
\note{
  SEXPs know their type and length

  have data pointer, e.g. integer array
}
\end{frame}

\begin{frame}{Common SEXP subtypes}

  \begin{tabular}{lll}
  R function   & SEXP subtype & Data accessor \\ \hline
  integer()    & INTSXP    & int *INTEGER(x)  \\
  numeric()    & REALSXP   & double *REAL(x)  \\
  logical()    & LGLSXP    & int *LOGICAL(x)           \\
  character()  & STRSXP    & CHARSXP STRING\_ELT(x, i) \\
  list()       & VECSXP    & SEXP VECTOR\_ELT(x, i)    \\
  NULL         & NILSXP    & R\_NilValue               \\
  externalptr  & EXTPTRSXP & SEXP (accessor funcs)
\end{tabular}
  \note{
    Will look at STRSXP/CHARSXP in detail next

    Exercise handout has EXTPTRSXP example

    All SEXP types in Rinternals.h
    }
\end{frame}

\begin{frame}[fragile]{STRSXP/CHARSXP Exercise}
  Try this:
  \begin{verbatim}

    .Internal(inspect(c("abc", "abc", "xyz")))

  \end{verbatim}

  \note{
    Observe pointer addresses

    Observe structure (STRSXP containing CHARSXP)
  }
\end{frame}

\begin{frame}[fragile]{STRSXP/CHARSXP Exercise}
\begin{verbatim}
> .Internal(inspect(c("abc", "abc", "xyz")))

 @101d3f280 16 STRSXP g0c3 [] (len=3, tl=1)
   @101cc6278 09 CHARSXP g0c1 [gp=0x20] "abc"
   @101cc6278 09 CHARSXP g0c1 [gp=0x20] "abc"
   @101cc6308 09 CHARSXP g0c1 [gp=0x20] "xyz"
\end{verbatim}
\end{frame}

\begin{frame}{character vectors == STRSXPs + CHARSXPs}

  \note{
    character() in R maps to STRSXPs which contain CHARSXPs

    CHARSXPs contain plain, nul-terminated C-strings
  }

  \begin{figure}[ht]
    \includegraphics[width=2.75in]{nativeI/strsxp1}
  \end{figure}

\end{frame}

\begin{frame}[fragile]{CHARSXPs are special}
  \begin{figure}[ht]
    \includegraphics[width=2.25in]{nativeI/strsxp2}
  \end{figure}

  \note{
    Create CHARSXPs with mkChar, mkCharLen

    No CHARSXPs at R-level

    There is a global cache of CHARSXPs

    never allocate a CHARSXP
  }
\end{frame}

\begin{frame}[fragile]{STRSXP/CHARSXP API Example}
\begin{semiverbatim}
\alert<1>{SEXP s = Rf_allocVector(STRSXP, 5);}
PROTECT(s);
\alert<2>{SET_STRING_ELT(s, 0, mkChar("hello"));}
\alert<3>{SET_STRING_ELT(s, 1, mkChar("goodbye"));}
\alert<4>{SEXP c = STRING_ELT(s, 0);}
\alert<5>{const char *v = CHAR(c);}
UNPROTECT(1);
\end{semiverbatim}
\end{frame}

\section{Memory management in R}

\begin{frame}{R's memory model (dramatization)}
    \begin{figure}[ht]
    \includegraphics[width=4.5in]{nativeI/DramatizationofRsMemoryModel}
  \end{figure}

    \note{
      R allocates, tracks, and garbage collects SEXPs

      gc is triggered by R functions

      SEXPs that are not \textit{in-use} are recycled.

      A SEXP is \textit{in-use} if: PROTECTed, Precious, reachable
    }
\end{frame}

\begin{frame}{R's memory model}
  \begin{itemize}
   \item R allocates, tracks, and garbage collects SEXPs
   \item gc is triggered by R functions
   \item SEXPs that are not \textit{in-use} are recycled.
   \item A SEXP is \textit{in-use} if:
    \begin{itemize}
    \item it is on the protection stack (PROTECT/UNPROTECT)
    \item it is in the precious list (R\_PreserveObject/R\_ReleaseObject)
    \item it is \textit{reachable} from a SEXP in the in-use list.
    \end{itemize}
  \end{itemize}
  \begin{figure}[hb]
    \includegraphics[width=3.5in]{nativeI/DramatizationofRsMemoryModel}
  \end{figure}

  \note{
    There is a variable reference to it at the R level

    The garbage collector traverses all SEXPs reachable from
    an in-use list.  Any SEXPs that were not reached from the
    traversal of the in-use list are eligible for collection.
  }

\end{frame}

\begin{frame}{Preventing gc of SEXPs with the protection stack}
\begin{tabular}{ll}
  \code{PROTECT(s)}   & Push \code{s} onto the protection stack \\
  \code{UNPROTECT(n)} & Pop top \code{n} items off of the protection stack
\end{tabular}

\note{
  If you PROTECT something, you must UNPROTECT it.

  Putting an item inside a protected container protects the item.

  PROTECT/UNPROTECT are cheap; when in doubt, PROTECT

  Arguments passed via .Call are already protected.
}

\end{frame}

\begin{frame}{Generic memory: When everything \textit{isn't} a SEXP}

  \begin{tabular}{|l|l|} \hline
    Allocation Function & Lifecycle \\ \hline
    \code{R\_alloc}           & Memory is freed when returning from .Call \\
    \code{Calloc}/\code{Free} & Memory persists until Free is called \\ \hline
  \end{tabular}

  \note{
    Built-in OOM error checking

    Generally, prefer over malloc, but memory leaks if OOM error
    }
\end{frame}

\begin{frame}[fragile]{Case Study: C implementation of \code{which}}
  Code review of \code{nidemo/src/which.c}
\end{frame}

\section{Self-Study Exercises}
%%
%% library("nidemo")
%% library("lattice")
%% ## English
%% english <- alpha_freq("/usr/share/dict/words")
%% ## Yeast Gene (YDL143W  Chr 4)
%% dna <- alpha_freq(system.file("extdata/Sc.fa", package="Biostrings"))
%% english1 <- english / sum(english)
%% dna1 <- dna / sum(dna)
%% dna2 <- dna1[order(dna1, decreasing=TRUE)][1:5]
%% eng <- english1[order(english1, decreasing = TRUE)][1:5]
%% pdf("nativeI/english.pdf")
%% barchart(eng[order(eng)], xlab="frequency", scales=list(cex=3.0))
%% dev.off()
%% pdf("nativeI/yeastgene.pdf")
%% barchart(dna2[order(dna2)], xlab="frequency", scales=list(cex=3.0))
%% dev.off()

\begin{frame}{Alphabet frequency of a text file}
\begin{columns}
  \column{0.5\textwidth}
  Yeast Gene YDL143W
  \begin{figure}
    \includegraphics[width=2in]{nativeI/yeastgene}
  \end{figure}
  \column{0.5\textwidth}
    English Dictionary
    \begin{figure}
    \includegraphics[width=2in]{nativeI/english}
  \end{figure}

\end{columns}
\end{frame}

\begin{frame}{Self-Study in nidemo package}
  \begin{enumerate}
  \item Alphabet Frequency
    \begin{itemize}
    \item Explore R and C implementations
    \item Make C implementation robust
    \item Attach names attribute in C
    \item multiple file, matrix return enhancement
    \end{itemize}
  \item External pointer example
  \item Calling R from C example and enhancement
  \item Debugging: a video how-to
  \end{enumerate}
\end{frame}


\section{Odds and Ends}

\begin{frame}{Odds and Ends}
  \begin{enumerate}
  \item Debugging
  \item Public API
  \item Calling R from C
  \item Making sense of the remapped function names
  \item Finding C implementations of R functions
  \item Using a TAGS file
  \end{enumerate}
\end{frame}

\begin{frame}[fragile]{Debugging Native Code}
\begin{verbatim}
Rprintf("DEBUG: v => %d, x => %s\n", v, x);
\end{verbatim}

\begin{verbatim}
$ R -d gdb
(gdb) run
> # now R is running
\end{verbatim}

\begin{quote}
  There are two ways to write error-free programs; only the third one works.

  -- Alan Perlis, \textit{Epigrams on Programming}
\end{quote}

\end{frame}

\begin{frame}[fragile]{R's Public API}
\begin{verbatim}
mkdir R-devel-build; cd R-devel-build
~/src/R-devel-src/configure && make
## hint: configure --help

ls include

  R.h     Rdefines.h   Rinterface.h  S.h
  R_ext/  Rembedded.h  Rinternals.h
\end{verbatim}

Details in WRE
\end{frame}

\begin{frame}{Calling R functions from C}
  \begin{enumerate}
    \item Build a pairlist
    \item call \code{Rf\_eval(s, rho)}
  \end{enumerate}

  \note{
    Example in hand out and nidemo package

    Creating environments not documented, but public
  }
\end{frame}

\begin{frame}{Remapped functions}
  \begin{itemize}
  \item Source is unadorned
  \item Preprocessor adds \code{Rf\_}
  \item Object code contains \code{Rf\_}
  \end{itemize}
  \note{
    Purpose is to avoid conflict with other libs for common names
    like length, error

    Package code can use either form, but consistency is good
  }
\end{frame}

\begin{frame}[fragile]{Finding C implementations}

\begin{verbatim}
cd R-devel/src/main

grep '"any"' names.c
{"any", do_logic3, 2, ...}

grep -l do_logic3 *.c
logic.c
\end{verbatim}

\note{names.c is the mapping table, R's internal function registration}
\end{frame}

\begin{frame}[fragile]{R CMD rtags}
\begin{verbatim}
cd R-devel/src
R CMD rtags --no-Rd
# creates index file TAGS
\end{verbatim}

\end{frame}

\section{Resources}

\begin{frame}{Writing R Extensions}

  \code{RShowDoc("R-exts")}

\end{frame}

\begin{frame}{Book: The C Programming Language (K \& R)}

  \begin{tabular}{ll}
    Java in a Nutshell           & 1264 pages \\
    The C++ Programming Language & 1030 pages \\
    The C Programming Language   & \alert{274} pages
  \end{tabular}
\end{frame}

\begin{frame}{Resources}
  \begin{itemize}
  \item \textbf{Read WRE and ``K \& R''}
  \item Use the sources for R and packages
  \item R-devel, bioc-devel mailing lists
  \item Patience
  \end{itemize}

  \begin{figure}
    \includegraphics[width=2in]{nativeI/chickenpatience.jpg}
  \end{figure}

\end{frame}


%% If debugging is the process of removing bugs, then programming must be
%% the process of putting them in.
%% Edsger W. Dijkstra

%% Debugging is twice as hard as writing the code in the first
%% place. Therefore, if you write the code as cleverly as possible, you
%% are, by definition, not smart enough to debug it.

%% Brian W. Kernighan and P. J. Plauger in The Elements of Programming Style.


%% If you lie to the computer, it will get you.
%% Perry Farrar

%% Computer programming is tremendous fun. Like music, it is a skill that
%% derives from an unknown blend of innate talent and constant
%% practice. Like drawing, it can be shaped to a variety of ends –
%% commercial, artistic, and pure entertainment. Programmers have a
%% well-deserved reputation for working long hours, but are rarely
%% credited with being driven by creative fevers. Programmers talk about
%% software development on weekends, vacations, and over meals not
%% because they lack imagination, but because their imagination reveals
%% worlds that others cannot see.
%% Larry O'Brien and Bruce Eckel in Thinking in C#

\end{document}

\name{scriptPath}
\alias{scriptPath}
\alias{readScript}

\title{
  Determine the file path and read scripts in this package.
}
\description{

  These helper functions locate and read scripts associated with the
  AdvancedR package.
  
}
\usage{
scriptPath(scriptName)
readScript(scriptName)
}

\arguments{

  \item{scriptName}{The name of the script, e.g.,
    \dQuote{fapply.R}. \code{scriptName} may be missing for
    \code{scriptPath}.}

}

\value{

  \code{scriptPath} returns the path to \code{scriptName} as
  \code{character(1)}. If \code{scriptName} is missing, the return value
  is the directory in which the scripts are installed.

  \code{readScript} returns the content of the script as
  \code{character()}, one line per script, arranging not to quote
  strings.

}
\author{
  Martin Morgan \url{mtmorgan@fhcrc.org}
}

\examples{
list.files(scriptPath()) # available scripts
scriptPath('fapply.R')
readScript('fapply.R')
}

\keyword{manip}

\name{AdvancedR-package}
\alias{AdvancedR-package}
\docType{package}
\title{

  Advanced R Programming for Bioinformatics, Seattle, May, 2010

}
\description{

  This package contains course material for \sQuote{Advanced R
    Programming for Bioinformatics}, offered in Seattle, 20-21 May,
  2010.

}
\details{

  Use \code{browseVignettes(package='AdvancedR')} for slides and other
  resources, including the \R{} code used in each slide.

  See \code{?scriptPath} to access scripts used to illustrate the
  slides or exercises.

  The \code{nidemo} package used for native interfaces is located at
  \code{system.file("packages", package="AdvancedR")}

}

\examples{
packageDescription('AdvancedR')
system.file("packages", package="AdvancedR") ## nidemo location
}
\keyword{package}
